package net.forwardfire.vasc.backend.select;

import java.io.Serializable;

public class DefaultVascBackendSelectItem<DATA_PK extends Serializable> implements VascBackendSelectItem<DATA_PK> {

	private final boolean header;
	private final boolean enabled;
	private final String name;
	private final boolean nameI18nKey;
	private final String description;
	private final boolean descriptionI18nKey;
	private final DATA_PK primaryKey;
	
	public DefaultVascBackendSelectItem(boolean header, boolean enabled,
			String name, boolean nameI18nKey, String description,
			boolean descriptionI18nKey, DATA_PK primaryKey) {
		super();
		this.header = header;
		this.enabled = enabled;
		this.name = name;
		this.nameI18nKey = nameI18nKey;
		this.description = description;
		this.descriptionI18nKey = descriptionI18nKey;
		this.primaryKey = primaryKey;
	}
	
	@Override
	public boolean isHeader() {
		return header;
	}
	
	@Override
	public boolean isEnabled() {
		return enabled;
	}
	
	@Override
	public String getName() {
		return name;
	}
	
	@Override
	public boolean isNameI18nKey() {
		return nameI18nKey;
	}
	
	@Override
	public String getDescription() {
		return description;
	}
	
	@Override
	public boolean isDescriptionI18nKey() {
		return descriptionI18nKey;
	}
	
	@Override
	public DATA_PK getPrimaryKey() {
		return primaryKey;
	}
}
