/*
 * Copyright 2007-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package net.forwardfire.vasc.backend.metamodel;

import java.io.File;

import org.eobjects.metamodel.DataContext;
import org.eobjects.metamodel.xml.XmlDomDataContext;

/**
 * MetaModelDataContextXmlDom provides basic auto xml editing support.
 * 
 * @author Willem Cazander
 * @version 1.0 May 20, 2012
 */
public class MetaModelDataContextXmlDom implements MetaModelDataContextProvider {

	private String file = null;
	private boolean autoFlattenTables = true;
	
	@Override
	public DataContext getDataContext() {
		if (file==null) {
			throw new NullPointerException("Can's provided data context with null file.");
		}
		XmlDomDataContext dataContext = new XmlDomDataContext(new File(file),autoFlattenTables);
		return dataContext;
	}


	/**
	 * @return the file
	 */
	public String getFile() {
		return file;
	}

	/**
	 * @param file the file to set
	 */
	public void setFile(String file) {
		this.file = file;
	}

	/**
	 * @return the autoFlattenTables
	 */
	public boolean isAutoFlattenTables() {
		return autoFlattenTables;
	}

	/**
	 * @param autoFlattenTables the autoFlattenTables to set
	 */
	public void setAutoFlattenTables(boolean autoFlattenTables) {
		this.autoFlattenTables = autoFlattenTables;
	}
}
