/*
 * Copyright 2007-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package net.forwardfire.vasc.backend.metamodel;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.logging.Logger;

import org.eobjects.metamodel.DataContext;
import org.eobjects.metamodel.UpdateableDataContext;
import org.eobjects.metamodel.data.DataSet;
import org.eobjects.metamodel.data.Row;
import org.eobjects.metamodel.jdbc.JdbcDataContext;
import org.eobjects.metamodel.query.OrderByItem.Direction;
import org.eobjects.metamodel.query.Query;
import org.eobjects.metamodel.query.SelectItem;
import org.eobjects.metamodel.query.builder.SatisfiedQueryBuilder;
import org.eobjects.metamodel.query.builder.SatisfiedWhereBuilder;
import org.eobjects.metamodel.schema.Column;
import org.eobjects.metamodel.schema.Schema;
import org.eobjects.metamodel.schema.Table;

import net.forwardfire.vasc.backend.VascBackendAccessDataRecord;
import net.forwardfire.vasc.backend.VascBackendException;
import net.forwardfire.vasc.backend.crud.VascBackendCrud;
import net.forwardfire.vasc.backend.list.DefaultVascBackendListResult;
import net.forwardfire.vasc.backend.list.VascBackendListResult;
import net.forwardfire.vasc.backend.list.VascBackendListRequest;
import net.forwardfire.vasc.backend.metamodel.crud.CrudDataContext;
import net.forwardfire.vasc.backend.metamodel.crud.UpdateableRow;
import net.forwardfire.vasc.backend.metamodel.crud.CrudDataContextImpl;
import net.forwardfire.vasc.backend.metamodel.crud.UpdateableRowMapImpl;

/**
 * MetaModelVascBackend provides vasc backend for metamodel.
 * 
 * @author Willem Cazander
 * @version 1.0 Dec 31, 2011
 */
public class MetaModelVascBackendCrud extends AbstractMetaModelVascBackend implements VascBackendCrud<HashMap<String,Serializable>,Row> {

	private Logger logger = Logger.getLogger(MetaModelVascBackendCrud.class.getName());
	private CrudDataContext crudDataContext = null;

	
	@Override
	protected void startBackendMetaModel() {
//		if (isUpdateableDataContext()) {
//			CrudDataContextImpl crudDataContextImpl = new CrudDataContextImpl(getUpdateableDataContext());
//			if (tableId!=null && tableId.isEmpty()==false) {
//				List<String> ids = new ArrayList<String>(1);
//				ids.add(tableId);
//				crudDataContextImpl.overridePrimaryKeysForTable(table,ids);	
//			}
//			crudDataContext = crudDataContextImpl;
//		}
	}
	
	@Override
	public VascBackendAccessDataRecord<HashMap<String, Serializable>, Row> createVascBackendAccessDataRecord() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Row newRecord() throws VascBackendException {
		return crudDataContext.createRow(crudDataContext.getTableByQualifiedLabel(getTable()));
	}
	
	@Override
	public Row fetch(HashMap<String, Serializable> recordPK) throws VascBackendException {
		// TODO Auto-generated method stub
		return null;
	}
	
	
	/**
	 * Returns casted version of data context.
	 */
	private UpdateableDataContext getUpdateableDataContext() {
		return (UpdateableDataContext)getDataContext();
	}
	
	/**
	 * Returns true when data context in updateable.
	 */
	private boolean isUpdateableDataContext() {
		return getDataContext() instanceof UpdateableDataContext;
	}
	
	public boolean isReadOnly() {
		return isUpdateableDataContext()==false;
	}
	
	@Override
	public Row persist(Row object) throws VascBackendException {
		if (crudDataContext==null) {
			return object;
		}
		crudDataContext.persist((UpdateableRow) object);
		return object;
	}
	
	@Override
	public Row merge(Row object) throws VascBackendException {
		if (crudDataContext==null) {
			return object;
		}
		return crudDataContext.merge((UpdateableRow) object);
	}
	
	@Override
	public void delete(HashMap<String, Serializable> recordPK) throws VascBackendException {
		if (crudDataContext==null) {
			return;
		}
		//crudDataContext.delete((UpdateableRow) object);
	}	
}
