package net.forwardfire.vasc.backend.metamodel.crud;

import java.util.List;

import org.eobjects.metamodel.data.Row;
import org.eobjects.metamodel.data.Style;
import org.eobjects.metamodel.query.SelectItem;
import org.eobjects.metamodel.schema.Column;

/**
 * AbstractUpdateableRow implements some setters of UpdateableRow interface.
 * 
 * @author Willem Cazander
 * @version 1.0 May 23, 2012
 */
@SuppressWarnings("serial")
abstract public class AbstractUpdateableRow extends AbstractRow implements UpdateableRow {
	
	// TODO: rm / move getValue and indexOf to AbstractRow after UpdateableRow interface change
	@Override
	public Object getValue(String columnName) {
		return getValue(indexOf(columnName));
	}
	public int indexOf(String columnName) {
		if (columnName==null) {
			throw new NullPointerException("Can't search for null column name.");
			//return UpdateableRow.INDEX_NOT_FOUND;
		}
		int index = 0;
		for (SelectItem si:getIndexedSelectItemList()) {
			if (si.getColumn().getName().equals(columnName)) {
				return index;
			}
			index++;
		}
		throw new IndexOutOfBoundsException("Can't find key of column: "+columnName);
		////return UpdateableRow.INDEX_NOT_FOUND;
	}
	
	public void setValue(Row row) {
		for (SelectItem selectItem:row.getSelectItems()) {
			Object value = row.getValue(selectItem);
			setValue(indexOf(selectItem),value);
		}
	}
	
	@Override
	public void setValue(String columnName,Object object) {
		setValue(indexOf(columnName), object);
	}
	
	@Override
	public void setValue(SelectItem selectItem,Object object) {
		setValue(indexOf(selectItem),object);
	}
	
	@Override
	public void setValue(Column column,Object object) {
		setValue(indexOf(column),object);
	}
	
	@Override
	public String[] getPrimaryKeys() {
		List<String> primaryKeys = getPrimaryKeysList();
		return primaryKeys.toArray(new String[primaryKeys.size()]);
	}
	
	public Row getSubSelectionFromImpl(AbstractUpdateableRow rowImpl,SelectItem[] selectItems) {		
		for (SelectItem selectItem:selectItems) {
			int index    = rowImpl.indexOf(selectItem);
			Object value = null;
			Style style  = null;
			
			if (selectItem.getSubQuerySelectItem() != null) {
				value = getValue(selectItem.getSubQuerySelectItem());
				style = getStyle(selectItem.getSubQuerySelectItem());
			}
			if (value == null) {
				value = getValue(selectItem);
				style = getStyle(selectItem);
			}
			rowImpl.setValue(index, value);
			rowImpl.setStyle(index, style);
		}
		return rowImpl;
	}
}
