package net.forwardfire.vasc.backend.metamodel.crud;

import org.eobjects.metamodel.UpdateableDataContext;
import org.eobjects.metamodel.schema.Table;

/**
 * CrudDataContext provides Create/Update/Delete operations on row level of table.
 * 
 * note: UpdateableDataContext can implement UpdateableRowDataContext interface to provide native support for UpdateableRow in DataSet.
 * 
 * @author Willem Cazander
 * @version 1.0 May 23, 2012
 */
public interface CrudDataContext extends UpdateableDataContext {

	/**
	 * Creates empty row to fill and persist.
	 */
	UpdateableRow createRow(Table table);
	
	/**
	 * Inserts row into table.
	 */
	void persist(UpdateableRow row);
	
	/**
	 * Merges row with table.
	 */
	UpdateableRow merge(UpdateableRow row);
	
	/**
	 * Deletes row from table.
	 */
	void delete(UpdateableRow row);
}
