package net.forwardfire.vasc.backend.metamodel.crud;

import org.eobjects.metamodel.data.DataSet;
import org.eobjects.metamodel.query.Query;
import org.eobjects.metamodel.query.builder.InitFromBuilder;

/**
 * UpdateableRowDataContext to let DataContexts integrate CrudDataContext without wrapping data.
 * 
 * @author Willem Cazander
 * @version 1.0 May 24, 2012
 */
public interface UpdateableRowDataContext {

	/**
	 * Gets called by executeQuery from crud to this impl which knows how to return UpdateableRow DataSet.
	 */
	DataSet crudExecuteQuery(CrudDataContext crudDataContext,Query query);
	
	/**
	 * Start the query builder with correct data context for execute call back.
	 */
	InitFromBuilder crudCreateQuery(CrudDataContext crudDataContext);
}
