package net.forwardfire.vasc.backend.metamodel.jndi;

import javax.naming.InitialContext;
import javax.naming.NamingException;

import org.eobjects.metamodel.DataContext;

/**
 * JndiDataContextProvider retreives a DataContext from the jndi tree by the jndiName.
 * 
 * 
 * @author Willem Cazander
 * @version 1.0 May 22, 2012
 */
public class JndiDataContextProvider implements DataContextProvider {

	private String jndiName = null;
	
	/**
	 * Returns an DataContext object from the jndi tree.
	 */
	@Override
	public DataContext getDataContext() {
		try {			
			InitialContext context = new InitialContext();
			DataContext dataContext = (DataContext)context.lookup(jndiName);
			return dataContext;
		} catch (NamingException e) {
			throw new IllegalStateException("Jndi naming error on: "+jndiName,e);
		}
	}

	/**
	 * @return the jndiName
	 */
	public String getJndiName() {
		return jndiName;
	}

	/**
	 * @param jndiName the jndiName to set
	 */
	public void setJndiName(String jndiName) {
		this.jndiName = jndiName;
	}
}
