package net.forwardfire.vasc.backend.metamodel.jndi;

import org.eobjects.metamodel.DataContext;
import org.eobjects.metamodel.MetaModelException;
import org.eobjects.metamodel.data.DataSet;
import org.eobjects.metamodel.query.CompiledQuery;
import org.eobjects.metamodel.query.Query;
import org.eobjects.metamodel.query.builder.InitFromBuilder;
import org.eobjects.metamodel.schema.Column;
import org.eobjects.metamodel.schema.Schema;
import org.eobjects.metamodel.schema.Table;

/**
 * JndiReadOnlyDataContext makes DataContext read only by removing the UpdateableDataContext interface.
 * 
 * @author Willem Cazanders
 * @version 1.0 May 22, 2012
 */
public class JndiReadOnlyDataContext /* extends DataContextProxy */ implements DataContext {
	
	private DataContext proxyDataContext = null;
	
	public JndiReadOnlyDataContext(DataContext proxyDataContext) {
		this.proxyDataContext=proxyDataContext;
	}
	
	@Override
	public DataSet executeQuery(Query arg0) throws MetaModelException {
		return proxyDataContext.executeQuery(arg0);
	}
	
	@Override
	public Column getColumnByQualifiedLabel(String arg0) {
		return proxyDataContext.getColumnByQualifiedLabel(arg0);
	}
	
	@Override
	public Schema getDefaultSchema() throws MetaModelException {
		return proxyDataContext.getDefaultSchema();
	}
	
	@Override
	public Schema getSchemaByName(String arg0) throws MetaModelException {
		return proxyDataContext.getSchemaByName(arg0);
	}
	
	@Override
	public String[] getSchemaNames() throws MetaModelException {
		return proxyDataContext.getSchemaNames();
	}
	
	@Override
	public Schema[] getSchemas() throws MetaModelException {
		return proxyDataContext.getSchemas();
	}
	
	@Override
	public Table getTableByQualifiedLabel(String arg0) {
		return proxyDataContext.getTableByQualifiedLabel(arg0);
	}
	
	@Override
	public InitFromBuilder query() {
		return proxyDataContext.query();
	}
	
	@Override
	public DataContext refreshSchemas() {
		return proxyDataContext.refreshSchemas();
	}
	
	@Override
	public Query parseQuery(String queryString) throws MetaModelException {
		return proxyDataContext.parseQuery(queryString);
	}
	
	@Override
	public DataSet executeQuery(String queryString) throws MetaModelException {
		return proxyDataContext.executeQuery(queryString);
	}
	
	@Override
	public CompiledQuery compileQuery(Query q) throws MetaModelException {
		return proxyDataContext.compileQuery(q);
	}
	
	@Override
	public DataSet executeQuery(CompiledQuery cq, Object... args) {
		return proxyDataContext.executeQuery(cq, args);
	}
}
