package net.forwardfire.vasc.backend.metamodel.jndi.loader;

import org.eobjects.metamodel.DataContext;

/**
 * JndiDataContextLoader loads and config the DataContext(DC) from the loader config.
 * This makes the jndi factory class independent from all MetaModel DC classes.
 * So we can have one factory for all DC without needing all DC libs in classpath when
 * most are not needed if using only one or two different DC's.
 * 
 * @author Willem Cazander
 * @version 1.0 May 22, 2012
 */
public interface JndiDataContextLoader {

	DataContext loadDataContext(JndiDataContextLoaderConfig config);
}
