package net.forwardfire.vasc.backend.metamodel.jndi.loader;

import org.eobjects.metamodel.DataContext;
import org.eobjects.metamodel.xml.XmlDomDataContext;

/**
 * JndiCsvDataContextLoader Loads and config xml dom DataContext from jndi loader config.
 * 
 * @author Willem Cazander
 * @version 1.0 May 22, 2012
 */
public class JndiXmlDomDataContextLoader implements JndiDataContextLoader {

	private boolean useUrlSource = false;
	
	public JndiXmlDomDataContextLoader() {
	}
	public JndiXmlDomDataContextLoader(boolean useUrlSource) {
		setUseUrlSource(useUrlSource);
	}
	
	@Override
	public DataContext loadDataContext(JndiDataContextLoaderConfig config) {
		boolean autoFlattenTables = true;
		if ("false".equalsIgnoreCase(config.getBackendParameters().get("autoFlattenTables"))) {
			autoFlattenTables = false;
		}
		if (useUrlSource) {
			return new XmlDomDataContext(config.checkBackendUrl(),autoFlattenTables);	
		} else {			
			return new XmlDomDataContext(config.checkFile(),autoFlattenTables);
		}
	}
	
	/**
	 * @return the useUrlSource
	 */
	public boolean isUseUrlSource() {
		return useUrlSource;
	}
	
	/**
	 * @param useUrlSource the useUrlSource to set
	 */
	public void setUseUrlSource(boolean useUrlSource) {
		this.useUrlSource = useUrlSource;
	}
}
