package net.forwardfire.vasc.backend.metamodel.x4o;

import java.util.ArrayList;
import java.util.List;

import net.forwardfire.vasc.backend.metamodel.MetaModelDataContextXmlSax;

import org.eobjects.metamodel.xml.XmlSaxTableDef;
import org.x4o.xml.element.AbstractElement;
import org.x4o.xml.element.Element;
import org.x4o.xml.element.ElementException;

public class XmlSaxSchemaElement extends AbstractElement {

	/**
	 * @see org.x4o.xml.element.AbstractElement#doElementRun()
	 */
	@Override
	public void doElementRun() throws ElementException {
		if (getElementClass().getId().endsWith("Column")) {
			return; // save one object to code.
		}
		if (getParent()==null) {
			throw new ElementException("Parent element is null.");
		}
		if (getParent().getElementObject()==null) {
			throw new ElementException("Parent object is null.");
		}
		if ((getParent().getElementObject() instanceof MetaModelDataContextXmlSax)==false) {
			throw new ElementException("Parent object is not MetaModelDataContextXmlSax class.");
		}
		String rowXPath = getAttributes().get("rowXPath");
		if (rowXPath==null) {
			throw new ElementException("Attribute rowXPath is null.");
		}
		if (rowXPath.isEmpty()) {
			throw new ElementException("Attribute rowXPath is empty.");
		}
		List<String> columns = new ArrayList<String>(15);
		for (Element e:getChilderen()) {
			String col = e.getAttributes().get("dataXPath");
			if (col==null) {
				throw new ElementException("Attribute dataXPath is null.");	
			}
			if (col.isEmpty()) {
				throw new ElementException("Attribute dataXPath is empty.");
			}
			columns.add(col);
		}
		MetaModelDataContextXmlSax saxDataContext = (MetaModelDataContextXmlSax)getParent().getElementObject();
		String[] args = new String[columns.size()];
		XmlSaxTableDef tableSchema = new XmlSaxTableDef(rowXPath,columns.toArray(args));
		saxDataContext.addTableSchema(tableSchema);
	}
}
