
import java.io.File;

import org.eobjects.metamodel.UpdateCallback;
import org.eobjects.metamodel.UpdateScript;
import org.eobjects.metamodel.csv.CsvDataContext;
import org.eobjects.metamodel.data.DataSet;
import org.eobjects.metamodel.data.Row;
import org.eobjects.metamodel.schema.Schema;
import org.eobjects.metamodel.schema.Table;
import org.eobjects.metamodel.util.MutableRef;

public class SwingLoadTest {
	private Table table = null;
	public static void main(String[] argu) {
		try {SwingLoadTest test = new SwingLoadTest();test.run(argu);} catch (Exception e) {e.printStackTrace();}
	}
	public void run(String[] argu) throws Exception {
		File tmpFile = File.createTempFile("test-class-loading", "csv");
		tmpFile.deleteOnExit();
		CsvDataContext dataContext = new CsvDataContext(tmpFile);
		final Schema schema = dataContext.getDefaultSchema();
		dataContext.executeUpdate(new UpdateScript() {
			@Override
            public void run(UpdateCallback cb) {
            	MutableRef<Table> tableRef = new MutableRef<Table>();
            	table = cb.createTable(schema, "table").withColumn("column").execute();
            	tableRef.set(table);
                cb.insertInto(table).value(0,"data").execute();
            }
        });
		DataSet ds = dataContext.query().from(table).select(table.getColumns()).execute();
		while (ds.next()) {
			Row row = ds.getRow();
			System.out.println("Row value contains "+row.getValue(0));
		}
		ds.close();
	}
}
