package net.forwardfire.vasc.backend.metamodel.bundle;

import java.io.File;

import org.eobjects.metamodel.DataContext;
import org.eobjects.metamodel.UpdateableDataContext;
import org.eobjects.metamodel.csv.CsvDataContext;
import org.eobjects.metamodel.data.DataSet;
import org.eobjects.metamodel.data.Row;
import org.eobjects.metamodel.schema.Table;

import junit.framework.TestCase;

public class ResouceBundleTest extends TestCase {

	public void testBundle() {
		final String tableName = "mm-bundle-test";  // Setup some small test data in tmp
		File testFile = new File(System.getProperty("java.io.tmpdir")+File.separatorChar+tableName+".properties");
		final boolean createTable = testFile.exists()==false;
		
		if (createTable) {
			return; // TODO fix test
		}
	
		
		DataContext dataContext = new ResourceBundleDataContext(testFile);
		assertTrue(dataContext instanceof UpdateableDataContext);
		
		for (String t:dataContext.getDefaultSchema().getTableNames()) {
			System.out.println("table: '"+t+"'");
		}
		
		Table table = dataContext.getDefaultSchema().getTableByName("en");
		assertNotNull(table);
		
		DataSet ds = dataContext.query().from(table).select(table.getColumns()).execute();
		while (ds.next()) {
			Row row = ds.getRow();
			System.out.println("row: "+row.getValue(0)+" "+row.getValue(1)+" "+row.getValue(2));
		}
	}
}
