/*
 * Copyright 2007-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package net.forwardfire.vasc.core;

import net.forwardfire.vasc.backend.VascBackendController;

/**
 * AbstractVascEntryFieldLocal
 * 
 * @author Willem Cazander
 * @version 1.0 Jun 2, 2012
 */
abstract public class AbstractVascControllerLocal implements VascControllerLocal {

	private VascEntryConfigController vascEntryConfigController = null;
	private VascBackendController vascBackendController = null;
	private VascEntryController vascEntryController = null;
	private VascEntryFieldTypeController vascEntryFieldTypeController = null;
	private VascEventChannelController vascEventChannelController = null;
	
	/**
	 * @return the vascEntryConfigController
	 */
	@Override
	public VascEntryConfigController getVascEntryConfigController() {
		return vascEntryConfigController;
	}

	/**
	 * @param vascEntryConfigController the vascEntryConfigController to set
	 */
	@Override
	public void setVascEntryConfigController(VascEntryConfigController vascEntryConfigController) {
		this.vascEntryConfigController = vascEntryConfigController;
	}

	/**
	 * @return the vascEventChannelController
	 */
	@Override
	public VascEventChannelController getVascEventChannelController() {
		return vascEventChannelController;
	}

	/**
	 * @param vascEventChannelController the vascEventChannelController to set
	 */
	@Override
	public void setVascEventChannelController(VascEventChannelController vascEventChannelController) {
		this.vascEventChannelController = vascEventChannelController;
	}

	/**
	 * @return the vascBackendController
	 */
	@Override
	public VascBackendController getVascBackendController() {
		return vascBackendController;
	}
	
	/**
	 * @param vascBackendController the vascBackendController to set
	 */
	@Override
	public void setVascBackendController(VascBackendController vascBackendController) {
		this.vascBackendController = vascBackendController;
	}
		
	/**
	 * @return the vascEntryController
	 */
	@Override
	public VascEntryController getVascEntryController() {
		return vascEntryController;
	}
	
	/**
	 * @param vascEntryController the vascEntryController to set
	 */
	@Override
	public void setVascEntryController(VascEntryController vascEntryController) {
		this.vascEntryController = vascEntryController;
	}
	
	/**
	 * @return the vascEntryFieldController
	 */
	@Override
	public VascEntryFieldTypeController getVascEntryFieldTypeController() {
		return vascEntryFieldTypeController;
	}
	
	/**
	 * @param vascEntryFieldController the vascEntryFieldController to set
	 */
	@Override
	public void setVascEntryFieldTypeController(VascEntryFieldTypeController vascEntryFieldTypeController) {
		this.vascEntryFieldTypeController = vascEntryFieldTypeController;
	}
}
