/*
 * Copyright 2007-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package net.forwardfire.vasc.core;

import net.forwardfire.vasc.backend.VascBackendController;


/**
 * VascControllerLocal are the set methods to config the controller.
 * 
 * @author Willem Cazander
 * @version 1.0 May 18, 2012
 */
public interface VascControllerLocal extends VascController {

	/**
	 * @param vascEntryConfigController the vascEntryConfigController to set
	 */
	void setVascEntryConfigController(VascEntryConfigController vascEntryConfigController);
	
	/**
	 * @param vascEventChannelController the vascEventChannelController to set
	 */
	void setVascEventChannelController(VascEventChannelController vascEventChannelController);
	
	/**
	 * @param vascBackendController the vascBackendController to set
	 */
	void setVascBackendController(VascBackendController vascBackendController);
	
	/**
	 * @param vascEntryController the vascEntryController to set
	 */
	void setVascEntryController(VascEntryController vascEntryController);
	
	/**
	 * @param vascEntryFieldController the vascEntryFieldController to set
	 */
	void setVascEntryFieldTypeController(VascEntryFieldTypeController vascEntryFieldTypeController);
}
