/*
 * Copyright 2007-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package net.forwardfire.vasc.core;

import java.util.List;

import net.forwardfire.vasc.backend.list.VascBackendListRequest;
import net.forwardfire.vasc.backend.proxy.VascBackendProxy;
import net.forwardfire.vasc.core.entry.VascEntryExport;
import net.forwardfire.vasc.core.entry.VascEntryFieldValidatorService;

/**
 * Interface to make default fill/etc config plugable.
 * 
 * @author Willem Cazander
 * @version 1.0 May 9, 2012
 */
public interface VascEntryConfigControllerLocal extends VascEntryConfigController {

	void putVascInterfaceImplemention(VascInterfaceKey key,Class<?> interfaceImpl);
	void putVascInterfaceImplementionFrontend(VascInterfaceKeyFrontend key,Class<?> interfaceImpl);
	
	
	void addVascEntryConfigFinalizer(VascEntryConfigFinalizer vascEntryConfigFinalizer);
	
	void removeVascEntryConfigFinalizer(VascEntryConfigFinalizer vascEntryConfigFinalizer);
	
	List<VascEntryConfigFinalizer> getVascEntryConfigFinalizers();
	
	
	void addVascBackendProxy(VascBackendProxy proxy);
	
	void removeVascBackendProxy(VascBackendProxy proxy);
	
	List<VascBackendProxy> getVascBackendProxies();
	
	
	void addVascEntryExporter(VascEntryExport exporter);
	
	void removeVascEntryExporter(VascEntryExport exporter);
	
	
	VascBackendListRequest getMasterVascBackendState();
	
	void setResourceBundle(String resourceBundle);
		
	void addVascEntryFieldValidatorService(VascEntryFieldValidatorService validator);
	
	void removeVascEntryFieldValidatorService(VascEntryFieldValidatorService validator);
	
	List<VascEntryFieldValidatorService> getVascEntryFieldValidatorServices();
}
