/*
 * Copyright 2007-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package net.forwardfire.vasc.core;

import java.io.Serializable;

import net.forwardfire.vasc.backend.VascBackendAccessDataRecord;
import net.forwardfire.vasc.core.base.VascBaseIdRoleCrudOrderMetaLocal;
import net.forwardfire.vasc.validators.VascValidator;

/**
 * VascEntryFieldLocal
 *  
 *  
 * @author Willem Cazander
 * @version 1.0 Jun 2, 2012
 */
public interface VascEntryFieldLocal extends VascEntryField,VascBaseIdRoleCrudOrderMetaLocal {
	
	/**
	 * @param entry the VascEntry to set
	 */
	void setVascEntry(VascEntry entry);
	
	/**
	 * @param vascEntryFieldType the vascEntryFieldType to set
	 */
	void setVascEntryFieldType(VascEntryFieldType vascEntryFieldType);
	
	/**
	 * @param backendName the backendName to set
	 */
	void setBackendName(String backendName);
	
	/**
	 * @param vascEntryFieldValue the vascEntryFieldValue to set
	 */
	void setVascEntryFieldValue(VascBackendAccessDataRecord<Serializable,Serializable> vascEntryFieldValue);
	
	/**
	 * @param vascValidator the vascValidator to add
	 */
	void addVascValidator(VascValidator vascValidator);
	
	/**
	 * @param vascValidator the vascValidator to remove
	 */
	void removeVascValidator(VascValidator vascValidator);
	
	/**
	 * @param defaultValue the defaultValue to set
	 */
	void setDefaultValue(Serializable defaultValue);
	
	/**
	 * @param sizeList the sizeList to set
	 */
	void setSizeList(Integer sizeList);
	
	/**
	 * @param sizeEdit the sizeEdit to set
	 */
	void setSizeEdit(Integer sizeEdit);
	
	/**
	 * @param styleList the styleList to set
	 */
	void setStyleList(String styleList);
	
	/**
	 * @param styleEdit the styleEdit to set
	 */
	void setStyleEdit(String styleEdit);
	
	/**
	 * @param choices the choices to set
	 */
	void setChoices(String choices);
	
	/**
	 * @param optional the optional to set
	 */
	void setOptional(Boolean optional);
	
	/**
	 * @param choicesAsRadio the choicesAsRadio to set
	 */
	void setChoicesAsRadio(Boolean choicesAsRadio);
	
	/**
	 * @param editBlank the editBlank to set
	 */
	void setEditBlank(Boolean editBlank);
	
	/**
	 * @param displayName the displayName to set
	 */
	void setDisplayName(String displayName);
	
	/**
	 * @param sortable the sortable to set
	 */
	void setSortable(Boolean sortable);
	
	/**
	 * @param sumable the sumable to set
	 */
	void setSumable(Boolean sumable);
	
	/**
	 * @param graphable the graphable to set
	 */
	void setGraphable(Boolean graphable);
	
	/**
	 * Force impl to have public clone method
	 * @return
	 * @throws CloneNotSupportedException
	 */
	VascEntryFieldLocal clone() throws CloneNotSupportedException;
}
