/*
 * Copyright 2007-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package net.forwardfire.vasc.core;

import java.util.List;

import org.x4o.xml.conv.ObjectConverter;

import net.forwardfire.vasc.core.base.VascBaseIdLocal;
import net.forwardfire.vasc.validators.VascValidator;

/**
 * 
 * @author Willem Cazander
 * @version 1.0 Jun 2, 2012
 */
public interface VascEntryFieldTypeLocal extends VascEntryFieldType,VascBaseIdLocal {
	
	void setUIComponentId(String uiComponentId);
	
	void setInputMask(String inputMask);
	
	void setAutoDetectClass(Class<?> classObject);
	
	@Override
	List<VascValidator> getVascValidators();
	void addVascValidator(VascValidator vascValidator);
	void removeVascValidator(VascValidator vascValidator);
	
	void setProperty(String name,String value);

	/**
	 * @param objectConverter the objectConverter to set
	 */
	void setObjectConverter(ObjectConverter objectConverter);
	
	/**
	 * Force impl to have public clone methode
	 * @return
	 * @throws CloneNotSupportedException
	 */
	VascEntryFieldTypeLocal clone() throws CloneNotSupportedException;
}
