/*
 * Copyright 2007-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package net.forwardfire.vasc.core;

import net.forwardfire.vasc.core.base.VascBaseIdRoleViewOrderMetaLocal;


/**
 * VascEntryLinkLocal
 * 
 * @author Willem Cazander
 * @version 1.0 Jun 2, 2012
 */
public interface VascEntryLinkLocal extends VascEntryLink,VascBaseIdRoleViewOrderMetaLocal {

	void addEntryParameterFieldId(String parameterName,String valueFieldId);
	
	void addEntryCreateFieldValue(String valueFieldId,String selectedFieldId);
	
	/**
	 * @param vascEntryId the vascEntryId to set
	 */
	void setVascEntryId(String vascEntryId);
	
	/**
	 * @param vascLinkEntryType the vascLinkEntryType to set
	 */
	void setVascEntryLinkType(VascEntryLinkType vascLinkEntryType);
	
	/**
	 * @param doActionId the doActionId to set
	 */
	void setDoActionId(String doActionId);
	
	/**
	 * Force impl to have public clone methode
	 * @return
	 * @throws CloneNotSupportedException
	 */
	VascEntryLinkLocal clone() throws CloneNotSupportedException;
}
