package net.forwardfire.vasc.core;

import net.forwardfire.vasc.backend.list.VascBackendListRequest;
import net.forwardfire.vasc.frontend.VascFrontendActions;
import net.forwardfire.vasc.frontend.VascFrontendControllerLocal;
import net.forwardfire.vasc.frontend.VascFrontendDataSelector;
import net.forwardfire.vasc.frontend.VascFrontendPageInfo;
import net.forwardfire.vasc.frontend.VascFrontendUserController;
import net.forwardfire.vasc.frontend.VascFrontendUserSettingController;


public interface VascInterfaceLoader {

	VascEntry createVascEntryImpl();
	VascEntryField createVascEntryFieldImpl();
	VascEntryFieldSet createVascEntryFieldSetImpl();
	VascEntryLink createVascEntryLinkImpl();
	VascEntryListOption createVascEntryListOptionImpl();
	
	
	VascEntryState createVascEntryStateImpl();
	VascBackendListRequest createVascBackendStateImpl();
	VascFrontendControllerLocal createVascFrontendControllerLocalImpl();
	
	
	VascFrontendPageInfo createVascFrontendPagerImpl(VascEntry entry);
	VascFrontendActions createVascFrontendActionsImpl(VascEntry entry); 
	VascFrontendDataSelector createVascFrontendDataSelectorImpl(VascEntry entry);
	VascFrontendUserController createVascFrontendUserControllerImpl(VascEntry entry);
	VascFrontendUserSettingController createVascFrontendUserSettingControllerImpl(VascEntry entry);
	
}
