/*
 * Copyright 2007-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package net.forwardfire.vasc.core.base;

/**
 * AbstractVascBaseIdRoleCrudLocal
 * 
 * @author Willem Cazander
 * @version 1.0 Jun 2, 2012
 */
@SuppressWarnings("serial")
abstract public class AbstractVascBaseIdRoleCrudLocal extends AbstractVascBaseIdRoleViewLocal implements VascBaseIdRoleCrudLocal {

	private Boolean list = null;
	private Boolean create = null;
	private Boolean edit = null;
	private Boolean editReadOnly = null;
	
	private String rolesCreate = null;
	private String rolesEdit = null;
	private String rolesEditReadOnly = null;
	private String rolesList = null;
	
	@Override
	public void cloneFields(Object cloneObject) throws CloneNotSupportedException {
		super.cloneFields(cloneObject);
		VascBaseIdRoleCrudLocal clone = (VascBaseIdRoleCrudLocal)cloneObject;
		clone.setList(getList());
		clone.setCreate(getCreate());
		clone.setEdit(getEdit());
		clone.setEditReadOnly(getEditReadOnly());
		clone.setRolesCreate(getRolesCreate());
		clone.setRolesEdit(getRolesEdit());
		clone.setEditReadOnly(getEditReadOnly());
		clone.setRolesList(getRolesList());
	}
	
	/**
	 * @return the create
	 */
	@Override
	public Boolean getCreate() {
		return create;
	}
	
	/**
	 * @param create the create to set
	 */
	@Override
	public void setCreate(Boolean create) {
		this.create = create;
	}
	
	/**
	 * @return the edit
	 */
	@Override
	public Boolean getEdit() {
		return edit;
	}
	
	/**
	 * @param edit the edit to set
	 */
	@Override
	public void setEdit(Boolean edit) {
		this.edit = edit;
	}
	
	/**
	 * @return the editReadOnly
	 */
	@Override
	public Boolean getEditReadOnly() {
		return editReadOnly;
	}
	
	/**
	 * @param editReadOnly the editReadOnly to set
	 */
	@Override
	public void setEditReadOnly(Boolean editReadOnly) {
		this.editReadOnly = editReadOnly;
	}
	
	/**
	 * @return the list
	 */
	@Override
	public Boolean getList() {
		return list;
	}
	
	/**
	 * @param list the list to set
	 */
	@Override
	public void setList(Boolean list) {
		this.list = list;
	}
	
	/**
	 * @return the rolesCreate
	 */
	@Override
	public String getRolesCreate() {
		return rolesCreate;
	}
	
	/**
	 * @param rolesCreate the rolesCreate to set
	 */
	@Override
	public void setRolesCreate(String rolesCreate) {
		this.rolesCreate = rolesCreate;
	}
	
	/**
	 * @return the rolesEdit
	 */
	@Override
	public String getRolesEdit() {
		return rolesEdit;
	}
	
	/**
	 * @param rolesEdit the rolesEdit to set
	 */
	@Override
	public void setRolesEdit(String rolesEdit) {
		this.rolesEdit = rolesEdit;
	}
	
	/**
	 * @return the rolesEditReadOnly
	 */
	@Override
	public String getRolesEditReadOnly() {
		return rolesEditReadOnly;
	}
	
	/**
	 * @param rolesEditReadOnly the rolesEditReadOnly to set
	 */
	@Override
	public void setRolesEditReadOnly(String rolesEditReadOnly) {
		this.rolesEditReadOnly = rolesEditReadOnly;
	}
	
	/**
	 * @return the rolesList
	 */
	@Override
	public String getRolesList() {
		return rolesList;
	}
	
	/**
	 * @param rolesList the rolesList to set
	 */
	@Override
	public void setRolesList(String rolesList) {
		this.rolesList = rolesList;
	}
}
