/*
 * Copyright 2007-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package net.forwardfire.vasc.core.base;

/**
 * AbstractVascBaseIdRoleCrudOrderLocal
 * 
 * @author Willem Cazander
 * @version 1.0 Jun 2, 2012
 */
@SuppressWarnings("serial")
abstract public class AbstractVascBaseIdRoleCrudOrderLocal extends AbstractVascBaseIdRoleCrudLocal implements VascBaseIdRoleCrudOrderLocal {

	private Integer order = null;
	private Integer orderCreate = null;
	private Integer orderEdit = null;
	private Integer orderList = null;
	
	@Override
	public void cloneFields(Object cloneObject) throws CloneNotSupportedException {
		super.cloneFields(cloneObject);
		VascBaseIdRoleCrudOrderLocal clone = (VascBaseIdRoleCrudOrderLocal)cloneObject;
		clone.setOrder(getOrder());
		clone.setOrderCreate(getOrderCreate());
		clone.setOrderEdit(getOrderEdit());
		clone.setOrderList(getOrderList());
	}
	
	/**
	 * @return the order
	 */
	@Override
	public Integer getOrder() {
		return order;
	}
	
	/**
	 * @param order the order to set
	 */
	@Override
	public void setOrder(Integer order) {
		this.order=order;
	}
	
	/**
	 * @return the orderCreate
	 */
	@Override
	public Integer getOrderCreate() {
		return orderCreate;
	}
	
	/**
	 * @param orderCreate the orderCreate to set
	 */
	@Override
	public void setOrderCreate(Integer orderCreate) {
		this.orderCreate = orderCreate;
	}

	/**
	 * @return the orderEdit
	 */
	@Override
	public Integer getOrderEdit() {
		return orderEdit;
	}
	
	/**
	 * @param orderEdit the orderEdit to set
	 */
	@Override
	public void setOrderEdit(Integer orderEdit) {
		this.orderEdit = orderEdit;
	}
	
	/**
	 * @return the orderList
	 */
	@Override
	public Integer getOrderList() {
		return orderList;
	}
	
	/**
	 * @param orderList the orderList to set
	 */
	@Override
	public void setOrderList(Integer orderList) {
		this.orderList = orderList;
	}
}
