/*
 * Copyright 2007-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package net.forwardfire.vasc.core.entry;

import java.io.Serializable;

import net.forwardfire.vasc.core.VascEntry;



/**
 * 
 * @author Willem Cazander
 * @version 1.0 Jul 05, 2010
 */
public interface VascEntryBackendEventListener extends Serializable {
	
	public enum VascBackendEventType {
		PRE_EXECUTE,
		PRE_PERSIST,
		PRE_MERGE,
		PRE_DELETE,
		PRE_PROVIDE_FIELD_VALUE,
		PRE_PROVIDE_RECORD_CREATOR,
		PRE_MOVE_DOWN,
		PRE_MOVE_UP,
		
		POST_EXECUTE,
		POST_PERSIST,
		POST_MERGE,
		POST_DELETE,
		POST_PROVIDE_FIELD_VALUE,
		POST_PROVIDE_RECORD_CREATOR,
		POST_MOVE_DOWN,
		POST_MOVE_UP
	}
	
	VascBackendEventType[] getEventTypes();
	
	/**
	 * Is executed when the type of event is fired.
	 * @param entry
	 * @param type
	 * @param data
	 */
	void vascEvent(VascEntry entry,Object data); 
}
