/*
 * Copyright 2007-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package net.forwardfire.vasc.core.entry;

import java.io.Serializable;

import net.forwardfire.vasc.core.VascEntry;



/**
 * 
 * @author Willem Cazander
 * @version 1.0 Aug 02, 2007
 */
public interface VascEntryFrontendEventListener extends Serializable {
	
	public enum VascFrontendEventType {
		EXCEPTION,
	
		PRE_CREATE,
		POST_CREATE,
		PRE_READ,
		POST_READ,
		PRE_UPDATE,
		POST_UPDATE,
		PRE_DELETE,
		POST_DELETE,
		
		SELECT,
		SORT,
		PAGE,
		SEARCH,
		
		OPTION_UPDATE,
	}
	
	VascFrontendEventType[] getEventTypes();
	
	/**
	 * Is executed when the type of event is fired.
	 * @param entry
	 * @param type
	 * @param data
	 */
	void vascEvent(VascEntry entry,Serializable data); 
}
