/*
 * Copyright 2007-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package net.forwardfire.vasc.core.ui;

import java.io.Serializable;

import net.forwardfire.vasc.backend.VascBackendException;
import net.forwardfire.vasc.core.VascEntryField;
import net.forwardfire.vasc.core.VascException;

/**
 * VascColumnValueModelListener
 * 
 * @author Willem Cazander
 * @version 1.0 Aug 12, 2007
 */
public class VascColumnValueModelListener implements VascValueModelListener {
	
	private VascEntryField vascEntryField = null;
	private Serializable bean = null;
	
	public VascColumnValueModelListener() {
	}
	
	public VascColumnValueModelListener(VascEntryField vascEntryField,Serializable bean) {
		setVascEntryField(vascEntryField);
		setBean(bean);
	}
	
	@Override
	public void valueUpdate(VascValueModel model) throws VascException {
		try {
			vascEntryField.getVascEntryFieldValue().setValue(vascEntryField.getBackendName(), bean, model.getValue());
		} catch (VascBackendException e) {
			throw new VascException(e);
		}
	}
	
	/**
	 * @return the vascEntryField
	 */
	public VascEntryField getVascEntryField() {
		return vascEntryField;
	}
	
	/**
	 * @param vascEntryField the vascEntryField to set
	 */
	public void setVascEntryField(VascEntryField vascEntryField) {
		this.vascEntryField = vascEntryField;
	}
	
	/**
	 * @return the bean
	 */
	public Serializable getBean() {
		return bean;
	}
	
	/**
	 * @param bean the bean to set
	 */
	public void setBean(Serializable bean) {
		this.bean = bean;
	}
}