/*
 * Copyright 2007-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package net.forwardfire.vasc.frontend;

import java.io.Serializable;

import net.forwardfire.vasc.core.VascEntryField;

/**
 * VascFrontendActions are the most common used actions in frontend implemention.
 * 
 * @author Willem Cazander
 * @version 1.0 Jan 22, 2012
 */
public interface VascFrontendActions extends VascFrontendEntry {
	
	void refreshData() throws VascFrontendException;
	
	Serializable createObject() throws VascFrontendException;
	
	void deleteObject() throws VascFrontendException;
	
	void persistObject() throws VascFrontendException;
	
	Serializable mergeObject() throws VascFrontendException;
	
	void sortAction(VascEntryField field) throws VascFrontendException;
	
	void searchAction(String searchString) throws VascFrontendException;
	
	void pageAction(Integer page) throws VascFrontendException;
	
	void moveUpAction(Serializable object) throws VascFrontendException;
	
	void moveDownAction(Serializable object) throws VascFrontendException;
}
