/*
 * Copyright 2007-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package net.forwardfire.vasc.frontend;

import java.util.List;

import net.forwardfire.vasc.core.VascEntry;
import net.forwardfire.vasc.core.VascEntryField;
import net.forwardfire.vasc.core.VascEntryLink;
import net.forwardfire.vasc.core.VascEntryLinkType;
import net.forwardfire.vasc.core.VascException;
import net.forwardfire.vasc.core.actions.RowVascAction;

/**
 * Helper for frontend rederer
 * 
 * @author Willem Cazander
 * @version 1.0 Apr 28, 2007
 */
public interface VascFrontendHelper {
	
	/*
	public boolean renderView(VascEntryField field);
	public boolean renderList(VascEntryField field);
	public boolean renderEdit(VascEntryField field);
	public boolean renderEditReadOnly(VascEntryField field);
	public boolean renderCreate(VascEntryField field);
	public boolean renderGlobalVascAction(GlobalVascAction action);
	public boolean renderRowVascAction(RowVascAction action);
	*/
	
	Integer getTotalColumnsWidth(VascEntry entry);
	
	List<VascEntryLink> getVascLinkEntryByType(VascEntry entry,VascEntryLinkType type);
	
	List<String> validateObjectField(VascEntryField field) throws VascException;
	
	boolean validateAndSetErrorText(VascEntry entry) throws VascException;
	
	void headerOptionsCreatedFillData(VascEntry entry) throws VascException;
	
	void editReadOnlyUIComponents(VascEntry entry);
	
	List<RowVascAction> getMultiRowActions(VascEntry entry);
	
	String getSelectedDisplayName(VascEntry entry);
	String getParentSelectedDisplayName(VascEntry entry);
	
}