/*
 * Copyright 2007-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package net.forwardfire.vasc.impl.actions;

import java.io.Serializable;

import net.forwardfire.vasc.core.VascEntry;
import net.forwardfire.vasc.core.VascException;
import net.forwardfire.vasc.core.actions.AbstractVascRowActionLocal;

/**
 * AddRowAction
 * 
 * @author Willem Cazander
 * @version 1.0 Mar 30, 2007
 */
public class AddRowAction extends AbstractVascRowActionLocal {
	
	private static final long serialVersionUID = 3400966729022979875L;
	static public final String ACTION_ID = "addRowAction";
	
	@Override
	protected String getActionId() {
		return ACTION_ID;
	}
	
	@Override
	public void doRowAction(VascEntry entry,Serializable rowObject) throws VascException {
		entry.getVascFrontendController().getVascEntryState().setEditCreate(true);
		Serializable object = entry.getVascFrontendController().getVascFrontendActions().createObject();
		entry.getVascFrontendController().getVascEntryState().setEntryDataObject(object);
		entry.getVascFrontendController().getVascFrontend().renderEdit();
	}
	
	/**
	 * @see net.forwardfire.vasc.core.actions.RowVascAction#isMultiRowAction()
	 */
	@Override
	public boolean isMultiRowAction() {
		return false;
	}
}