/*
 * Copyright 2007-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package	net.forwardfire.vasc.impl.x4o;

import net.forwardfire.vasc.core.VascEntryField;
import net.forwardfire.vasc.core.VascEntryFieldType;
import net.forwardfire.vasc.core.ui.VascSelectItemModel;

import org.x4o.xml.element.AbstractElementBindingHandler;
import org.x4o.xml.element.Element;
import org.x4o.xml.element.ElementBindingHandlerException;

/**
 * Binds SelectItems 
 * 
 * 
 * @author Willem Cazander
 * @version 1.0 Apr 02, 2009
 */
public class SelectItemModelBindingHandler extends AbstractElementBindingHandler<VascEntryField> {
	
	private final static Class<?>[] CLASSES_CHILD = new Class[] {
		VascSelectItemModel.class
	};
	
	/**
	 * @see org.x4o.xml.element.ElementBindingHandler#getBindParentClass()
	 */
	@Override
	public Class<?> getBindParentClass() {
		return VascEntryField.class;
	}
	
	/**
	 * @see org.x4o.xml.element.ElementBindingHandler#getBindChildClasses()
	 */
	@Override
	public Class<?>[] getBindChildClasses() {
		return CLASSES_CHILD;
	}
	
	@Override
	public void bindChild(Element childElement, VascEntryField parentObject,Object childObject) throws ElementBindingHandlerException {
		if (childObject instanceof VascSelectItemModel) {			
			VascEntryFieldType type = parentObject.getVascEntryFieldType();
			type.setDataObject(childObject);
		}
	}
	
	@Override
	public void createChilderen(Element parentElement, VascEntryField parentObject)	throws ElementBindingHandlerException {
		createChild(parentElement, parentObject.getVascEntryFieldType().getDataObject());
	}
}
