/*
 * Copyright 2007-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package	net.forwardfire.vasc.impl.x4o;

import net.forwardfire.vasc.core.VascEntryFieldLocal;
import net.forwardfire.vasc.core.VascEntryListOptionLocal;
import net.forwardfire.vasc.core.VascEntryLocal;

import org.x4o.xml.element.AbstractElementBindingHandler;
import org.x4o.xml.element.Element;
import org.x4o.xml.element.ElementBindingHandlerException;

/**
 * Binds fields 
 * 
 * 
 * @author Willem Cazander
 * @version 1.0 Apr 02, 2009
 */
public class VascEntryFieldBindingHandler extends AbstractElementBindingHandler<VascEntryLocal> {
	
	private final static Class<?>[] CLASSES_CHILD = new Class[] {
		VascEntryFieldLocal.class,
		VascEntryListOptionLocal.class
	};
	
	/**
	 * @see org.x4o.xml.element.ElementBindingHandler#getBindParentClass()
	 */
	@Override
	public Class<?> getBindParentClass() {
		return VascEntryLocal.class;
	}

	/**
	 * @see org.x4o.xml.element.ElementBindingHandler#getBindChildClasses()
	 */
	@Override
	public Class<?>[] getBindChildClasses() {
		return CLASSES_CHILD;
	}
	
	@Override
	public void bindChild(Element childElement, VascEntryLocal parentObject,Object childObject) throws ElementBindingHandlerException {
		if (childObject instanceof VascEntryFieldLocal & (childObject instanceof VascEntryListOptionLocal)==false) {			
			VascEntryFieldLocal child = (VascEntryFieldLocal) childObject;
			parentObject.addVascEntryField(child);
		}
		if (childObject instanceof VascEntryListOptionLocal) {			
			VascEntryListOptionLocal child = (VascEntryListOptionLocal) childObject;
			parentObject.addVascEntryListOption(child);
		}
	}
	
	@Override
	public void createChilderen(Element parentElement, VascEntryLocal parentObject)	throws ElementBindingHandlerException {
		for (VascEntryFieldLocal field:parentObject.getVascEntryFieldsLocal()) {
			createChild(parentElement, field);
		}
		for (VascEntryListOptionLocal field:parentObject.getVascEntryListOptionsLocal()) {
			createChild(parentElement, field);
		}
	}
}
