/*
 * Copyright 2007-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package net.forwardfire.vasc.impl.x4o;

import net.forwardfire.vasc.backend.object.VascSelectItemModelEntry;
import net.forwardfire.vasc.core.VascEntryLinkLocal;

import org.x4o.xml.element.AbstractElement;
import org.x4o.xml.element.ElementException;

/**
 * Adds the link is paramets
 * 
 * @author Willem Cazander
 * @version 1.0 Jun 09, 2009
 */
public class VascEntryLinkParameterElement extends AbstractElement {

	/**
	 * @see org.x4o.xml.element.AbstractElement#doElementRun()
	 */
	@Override
	public void doElementRun() throws ElementException {
		String valueFieldId = getAttributes().get("valueFieldId");
		String parameterName = getAttributes().get("name");
		String selectedFieldId = getAttributes().get("selectedFieldId");
		
		if (getParent().getElementObject() instanceof VascSelectItemModelEntry) {
			VascSelectItemModelEntry m = (VascSelectItemModelEntry)getParent().getElementObject();
			m.addEntryParameterFieldId(parameterName, valueFieldId);
			return;
		}
		if (getParent().getElementObject() instanceof VascEntryLinkLocal) {
			VascEntryLinkLocal link = (VascEntryLinkLocal)getParent().getElementObject();
			if (parameterName!=null) {
				// normal parameter
				link.addEntryParameterFieldId(parameterName, valueFieldId);
			} else {
				link.addEntryCreateFieldValue(valueFieldId,selectedFieldId);
			}
			return;
		}
		throw new ElementException("Unsupported parent object: "+getParent().getElementObject());
	}
}