/*
 * Copyright 2007-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package net.forwardfire.vasc.validators;

import net.forwardfire.vasc.core.VascEntry;

/**
 * The VascValidator interface
 * 
 * @author Willem Cazander
 * @version 1.0 May 14, 2009
 */
public class VascValidatorMessages {


	public String getErrorI18nKey(VascValidator val) {
		return "vasc.validator."+val.getClass().getSimpleName();
	}

	public String getErrorMessage(VascEntry entry,VascValidator val) {
		String key = getErrorI18nKey(val);
		String message = entry.getVascFrontendController().getVascEntryResourceResolver().getTextValue(key);
		if (val instanceof VascIntSizeValidator) {
			VascIntSizeValidator v = (VascIntSizeValidator)val;
			message = entry.getVascFrontendController().getVascEntryResourceResolver().getTextValue(key,v.getMin(),v.getMax());
			return message;
		}
		if (val instanceof VascLongSizeValidator) {
			VascLongSizeValidator v = (VascLongSizeValidator)val;
			message = entry.getVascFrontendController().getVascEntryResourceResolver().getTextValue(key,v.getMin(),v.getMax());
			return message;
		}
		if (val instanceof VascStringLengthValidator) {
			VascStringLengthValidator v = (VascStringLengthValidator)val;
			message = entry.getVascFrontendController().getVascEntryResourceResolver().getTextValue(key,v.getMinLenght(),v.getMaxLenght());
			return message;
		}
		if (val instanceof VascStringRegexValidator) {
			VascStringRegexValidator v = (VascStringRegexValidator)val;
			message = entry.getVascFrontendController().getVascEntryResourceResolver().getTextValue(key,v.getRegEx());
			return message;
		}
		return message; 
	} 
}