package net.forwardfire.vasc.demo.server.tomcat;

import javax.naming.NameClassPair;
import javax.naming.NamingException;

public class JdniTreePrinter {
	
	boolean printXml = true;
	
	public JdniTreePrinter(boolean printXml) {
		this.printXml=printXml;
	}
	
	public void printJNDITree(javax.naming.Context context,String ct,StringBuffer buf) {
		if (printXml) {
			buf.append("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n");
			buf.append("<NamingRoot name=\""+ct+"\">\n");
		}
		printTree(context,ct,buf);
		if (printXml) {
			buf.append("</NamingRoot>\n");
		}
	}

	public void printTree(javax.naming.Context context,String ct,StringBuffer buf) {
		try {
			printNE(context,context.list(ct), ct,buf);
		} catch (NamingException e) {
			//ignore leaf node exception
		}
	}
	
	private void printNE(javax.naming.Context context,javax.naming.NamingEnumeration<?> ne, String parentctx,StringBuffer buf) throws NamingException {
		if (ne==null) {
			return;
		}
		while (ne.hasMoreElements()) {
			NameClassPair next = (NameClassPair) ne.nextElement();
			if (printXml) {
				printIndent(buf);
				buf.append("<NamingRoot name=\""+next.getName()+"\" className=\""+next.getClassName()+"\">\n");
				increaseIndent();
				printTree(context,(parentctx.length() == 0) ? next.getName() : parentctx + "/" + next.getName(),buf);
				decreaseIndent();
				
				printIndent(buf);
				buf.append("</NamingRoot>\n");
			} else {
				printEntry(next,buf);
				increaseIndent();
				printTree(context,(parentctx.length() == 0) ? next.getName() : parentctx + "/" + next.getName(),buf);
				decreaseIndent();
			}
		}
	}

	private void printEntry(javax.naming.NameClassPair next,StringBuffer buf) {
		printIndent(buf);
		buf.append("-->");
		buf.append(next);
		buf.append("\n");
	}


	private int indentLevel = 0;

	private void increaseIndent() {
		indentLevel += 4;
	}

	private void decreaseIndent() {
		indentLevel -= 4;
	}

	private void printIndent(StringBuffer buf) {
		for (int i = 0; i < indentLevel; i++) {
			buf.append(" ");
		}
	}
}
