package net.forwardfire.vasc.demo.server.tomcat;

import java.io.IOException;
import java.io.PrintWriter;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.openejb.loader.SystemInstance;
import org.apache.openejb.spi.ContainerSystem;

import net.forwardfire.vasc.demo.server.core.VascTechDemoStartup;

public class JndiDebugServlet extends HttpServlet {
	private static final long serialVersionUID = -7624183395089913214L;
	@Override
	protected void doGet(HttpServletRequest req, HttpServletResponse response) throws ServletException, IOException {
		try {
			Context context = null;
			if (req.getRequestURI().endsWith("global")) {
				context = VascTechDemoStartup.getInstance().getTomcatService().getServer().getGlobalNamingContext();
			} else if (req.getRequestURI().endsWith("openejb")) {
				ContainerSystem containerSystem = SystemInstance.get().getComponent(ContainerSystem.class);
				context = containerSystem.getJNDIContext();
			} else if (req.getRequestURI().endsWith("java")) {
				context = new InitialContext();
			}
			StringBuffer buf = new StringBuffer();
			JdniTreePrinter printer = null;
			if ("text".equals(req.getParameter("type"))) {
				printer = new JdniTreePrinter(false);
			} else {
				printer = new JdniTreePrinter(true);
			}
			if (req.getRequestURI().endsWith("global")) {
				printer.printJNDITree(context,"",buf);
			} else if (req.getRequestURI().endsWith("openejb")) {
				printer.printJNDITree(context,"",buf);
			} else if (req.getRequestURI().endsWith("java")) {
				printer.printJNDITree(context,"java:",buf);
			} else {
				response.setStatus(HttpServletResponse.SC_INTERNAL_SERVER_ERROR);
				buf.append("Unknown uri postfix.");
			}
			PrintWriter out = response.getWriter();
			out.append(buf.toString());
			out.flush();
		} catch (Exception e) {
			e.printStackTrace();
		}
		
	}
}