/*
 * Copyright 2007-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package net.forwardfire.vasc.demo.server.ui.load;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;

import net.forwardfire.vasc.backend.metamodel.MetaModelDataContextCsv;
import net.forwardfire.vasc.opt.metamodel.MetaModelSchemaAutoEntry;

/**
 * JDialogMetaCsv Add and runs MetaModel Schema Auto Entry code.
 * 
 * @author Willem Cazander
 * @version 1.0 May 9, 2012
 */
public class JLoadStepMetaCsv extends JPanel implements ActionListener {

	private static final long serialVersionUID = -8638394652416472734L;

	public JLoadStepMetaCsv(Frame aFrame) {
		//setTitle("Add csv file");
		setMinimumSize(new Dimension(640,480));
		setPreferredSize(new Dimension(999,666));
		JPanel mainPanel = new JPanel();
		mainPanel.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
		mainPanel.setLayout(new BorderLayout());
		//mainPanel.add(createPanelTop(),BorderLayout.NORTH);
		mainPanel.add(createPanelCenter(),BorderLayout.CENTER);
		//mainPanel.add(createPanelBottom(),BorderLayout.SOUTH);
		add(mainPanel);
	}
	
	public void clearAndHide() {
		setVisible(false);
	}
	
	public JPanel createPanelCenter() {
		JPanel result = new JPanel();
		//result.setLayout(new SpringLayout());
		
		result.add(new JLabel("File"));
		JButton fileButton = new JButton("Open");
		fileButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				final JFileChooser fc = new JFileChooser();
				int returnVal = fc.showOpenDialog((JButton)e.getSource());
				if (returnVal == JFileChooser.APPROVE_OPTION) {
					File file = fc.getSelectedFile();
					MetaModelDataContextCsv ds = new MetaModelDataContextCsv();
					ds.setFile(file.getAbsolutePath());
					
					MetaModelSchemaAutoEntry schema = new MetaModelSchemaAutoEntry();
					schema.setDataContextProvider(ds);
					schema.setEntryPrefix(file.getName());
					//schema.autoCreateEntries(VascTechDemoStartup.getInstance().getVascControllerService().getVascController());
					//VascTechDemoStartup.getInstance().getVascControllerService().fireChangeEvent();
				}
			}
		});
		result.add(fileButton);
		
		return result;
	}
	
	public void actionPerformed(ActionEvent arg0) {
		// TODO Auto-generated method stub
		
	}		
}
