/*
 * Copyright 2007-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package net.forwardfire.vasc.demo.server.ui.load;

import java.awt.FlowLayout;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.SpringLayout;

import net.forwardfire.vasc.demo.server.ui.SpringLayoutGrid;

/**
 * JLoadStepMiscInfo
 * 
 * @author Willem Cazander
 * @version 1.0 Nov 21, 2012
 */
public class JLoadStepMiscInfo extends JPanel implements LoadStep {

	private static final long serialVersionUID = -8638394652416472734L;
	private JTextField filenameField = null;
	private JTextField groupIdField = null;
	private JTextField rolesGroupField = null;
	private JTextField rolesEntryField = null;

	public JLoadStepMiscInfo() {
		setLayout(new FlowLayout(FlowLayout.LEFT));
		add(createPanelCenter());
	}
	
	public String getStepTitle() {
		return "Select Info";
	}
	
	public JPanel getPanel() {
		return this;
	}
	
	public JPanel createPanelCenter() {
		JPanel result = new JPanel();
		result.setLayout(new SpringLayout());

		filenameField = new JTextField();
		groupIdField = new JTextField();
		rolesGroupField = new JTextField();
		rolesEntryField = new JTextField();
		
		result.add(new JLabel("Filename:"));
		result.add(filenameField);
		result.add(new JLabel("groupId:"));
		result.add(groupIdField);
		result.add(new JLabel("rolesGroup:"));
		result.add(rolesGroupField);
		result.add(new JLabel("rolesEntry:"));
		result.add(rolesEntryField);
		
		SpringLayoutGrid.makeCompactGrid(result, 4, 2);
		return result;
	}

	public void setupStep(LoadStepData model) {
		filenameField.setText(model.name+".xml");
		groupIdField.setText(model.name);
		rolesGroupField.setText("login,admin");
		rolesEntryField.setText("login,admin");
	}
	
	@Override
	public boolean performStep(LoadStepData model) {
		model.filename = filenameField.getText();
		model.groupId = groupIdField.getText();
		model.rolesGroup =  rolesGroupField.getText();
		model.rolesEntry =  rolesEntryField.getText();
		return true;
	}
}
