package net.forwardfire.vasc.demo.tech.domain.petstore.model;

import java.io.Serializable;

import net.forwardfire.vasc.backend.VascBackendAccessDataRecord;
import net.forwardfire.vasc.backend.crud.VascBackendCrud;
import net.forwardfire.vasc.backend.list.DefaultVascBackendListRequest;
import net.forwardfire.vasc.backend.list.VascBackendList;
import net.forwardfire.vasc.backend.list.VascBackendListFeature;
import net.forwardfire.vasc.backend.list.VascBackendListRequest;
import net.forwardfire.vasc.backend.list.VascBackendListResult;
import net.forwardfire.vasc.backend.select.VascBackendSelect;

public final class AbstractPetStoreVascBackend {
	public interface CategoryBackend extends VascBackendCrud<Long,Category> {}
	public interface CategoryProductBackend extends VascBackendCrud<Long,CategoryProduct> {}
	public interface ItemBackend extends VascBackendCrud<Long,Item> {}
	public interface ItemInventoryBackend extends VascBackendCrud<Long,ItemInventory> {}
	public interface ItemSupplierBackend extends VascBackendCrud<Long,ItemSupplier> {}
	public interface OrderBackend extends VascBackendCrud<Long,Order> {}
	public interface OrderLineBackend extends VascBackendCrud<Long,OrderLine> {}
	public interface OrderStatusBackend extends VascBackendCrud<Long,OrderStatus> {}
	public interface UserAccountBackend extends VascBackendCrud<Long,UserAccount> {}
	public interface UserCredentialBackend extends VascBackendCrud<Long,UserCredential> {}
	
	public interface UserProfileBackend extends VascBackendCrud<Long,UserProfile> {}
	public interface UserProfileBackendList extends VascBackendList<Long,UserProfile> {}
	public interface UserProfileBackendSelect extends VascBackendSelect<Long> {}
	
	
	interface BackendCreator<DATA_PK extends Serializable,DATA_RECORD extends Serializable> {
		VascBackendList<DATA_PK,DATA_RECORD> createList();
		VascBackendCrud<DATA_PK,DATA_RECORD> createCrud();
		VascBackendSelect<DATA_PK> createSelect();
	}
	
	static {
		try {
			UserProfileBackend test = null;
			VascBackendAccessDataRecord<Long,UserProfile> f = test.createVascBackendAccessDataRecord();
			Long tweevle = f.getPrimaryKey(test.fetch(12l));
			test.delete(tweevle);
			UserProfile upNew = test.newRecord();
			upNew.setLocale("NL");
			upNew.setSignUpAgent("test");
			upNew = test.merge(upNew);
			
			test.newRecord(); // Create
			test.fetch(null); // Read
			test.merge(null); // Update
			test.delete(null);// Delete
			test.getId();                      // backend id
			//test.provideVascEntryFieldValue(); // field+pk <-> data
			
			
			UserProfileBackendList upList = null;
			
			boolean pagingSupport = upList.getSupportedFeatures().contains(VascBackendListFeature.PAGE_DATA);
			
			DefaultVascBackendListRequest request = new DefaultVascBackendListRequest();
			request.setPageIndex(2);
			request.setDataParameter("a", "b");
			VascBackendListResult<UserProfile> re = upList.execute(request);
			re.getData();
			re.getDataExtra();
			re.getTotalRecordCount();
			
			upList.execute(null);                   // Read List
			//upList.doRecordMoveUpById(null,null);   // up
			//upList.doRecordMoveDownById(null,null); // down
			upList.getSupportedFeatures();          // features
			//upList.provideVascEntryFieldValue();    // field+pk <-> data
			
		} catch (Exception e) {
			
		}
	}
	
	
}
