package net.forwardfire.vasc.demo.tech.domain.petstore.model;

import java.util.Date;

import net.forwardfire.vasc.annotations.VascDefaultValue;
import net.forwardfire.vasc.annotations.VascDisplayName;
import net.forwardfire.vasc.annotations.VascField;
import net.forwardfire.vasc.annotations.VascFieldOrder;
import net.forwardfire.vasc.annotations.VascFieldType;
import net.forwardfire.vasc.annotations.VascI18n;
import net.forwardfire.vasc.annotations.VascPrimaryKey;
import net.forwardfire.vasc.annotations.VascRoles;
import net.forwardfire.vasc.annotations.VascStyle;
import net.forwardfire.vasc.validators.VascObjectNotNull;
import net.forwardfire.vasc.validators.VascStringLength;


abstract public class AbstractPetStoreVascFieldTemplate {
	
	/**
	 * Template for field ids.
	 */
	@VascPrimaryKey
	@VascI18n(name="generic.id.labelText",description="generic.id.toolTipText")
	@VascStyle(sizeList=50)
	@VascField(create=false,editReadOnly=true)
	@VascFieldOrder(order=0)
	abstract public Long getId();
	
	/**
	 * Template for field names.
	 */
	@VascDisplayName
	@VascI18n(name="generic.name.labelText",description="generic.name.toolTipText")
	@VascObjectNotNull
	@VascStringLength(min=4,max=128)
	@VascStyle(sizeList=250,sizeEdit=40)
	@VascFieldOrder(order=1)
	abstract public String getName();
	
	/**
	 * Template for description field names.
	 */
	@VascI18n(name="generic.description.labelText",description="generic.description.toolTipText")
	@VascFieldType(type="TextAreaField",properties={"editor.columns=40","editor.rows=5"})
	@VascDefaultValue(value="")
	@VascField(list=false)
	@VascStringLength(max=4096)
	@VascObjectNotNull
	@VascFieldOrder(order=2)
	abstract public String getDescription();
	
	/**
	 * Template for active field.
	 */
	@VascI18n(name="generic.active.labelText",description="generic.active.toolTipText")
	@VascDefaultValue(value="true")
	@VascObjectNotNull
	@VascFieldOrder(order=4)
	@VascField(create=false)
	@VascRoles(rolesEdit="datafeedsPowerRole",rolesList="datafeedsPowerRole")
	abstract public Boolean getActive();
	
	/**
	 * Template for modified date.
	 */
	@VascI18n(name="generic.modifiedDate.labelText",description="generic.modifiedDate.toolTipText")
	@VascField(create=false,editReadOnly=true,list=false)
	@VascObjectNotNull
	abstract public Date getModifiedDate();
	
	/**
	 * Template for created date.
	 */
	@VascI18n(name="generic.createdDate.labelText",description="generic.createdDate.toolTipText")
	@VascField(create=false,editReadOnly=true,list=false)
	@VascObjectNotNull
	abstract public Date getCreatedDate();
}
