package net.forwardfire.vasc.demo.tech.domain.petstore.model;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;

import net.forwardfire.vasc.annotations.VascField;
import net.forwardfire.vasc.annotations.VascFieldTemplate;

@Entity
@Table(name=AbstractPetStoreDBTable.ITEM_SUPPLIER,schema=AbstractPetStoreDBCatalog.SCHEMA)
@SuppressWarnings("serial")
public class ItemSupplier implements Serializable {

	private Long id;
	private String name = null;
	private String description = null;
	private String website = null;
	
	@Column(name="name",nullable=false)
	@VascFieldTemplate(templateClass=AbstractPetStoreVascFieldTemplate.class)
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	
	@Id
	@Column(name=AbstractPetStoreDBColumn.ID,nullable=false)
	@VascFieldTemplate(templateClass=AbstractPetStoreVascFieldTemplate.class)
	public Long getId() {
		return id;
	}
	
	public void setId(Long id) {
		this.id = id;
	}
	
	@Column(name="description",nullable=false)
	@VascFieldTemplate(templateClass=AbstractPetStoreVascFieldTemplate.class)
	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}
	
	@Column(name="website",nullable=false)
	@VascField(list=false)
	public String getWebsite() {
		return website;
	}
	public void setWebsite(String website) {
		this.website = website;
	}
}
