package net.forwardfire.vasc.demo.tech.domain.petstore.model;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;
import javax.persistence.Table;

import net.forwardfire.vasc.annotations.VascField;
import net.forwardfire.vasc.annotations.VascFieldTemplate;
import net.forwardfire.vasc.annotations.VascModelReference;

@Entity
@Table(name=AbstractPetStoreDBTable.ORDER,schema=AbstractPetStoreDBCatalog.SCHEMA)
@SuppressWarnings("serial")
public class Order implements Serializable {
	
	private Long id;
	private UserAccount userAccount = null;
	private Date orderDate = null;
	private Date shipDate = null;
	
	private String shipAddr1 = null;
	private String shipAddr2 = null;
	private String shipCity = null;
	private String shipZipCode = null;
	private String shipCountry = null;
	
	private String billAddr1 = null;
	private String billAddr2 = null;
	private String billCity = null;
	private String billZipCode = null;
	private String billCountry = null;
	
	@Id
	@Column(name=AbstractPetStoreDBColumn.ID,nullable=false)
	@VascFieldTemplate(templateClass=AbstractPetStoreVascFieldTemplate.class)
	public Long getId() {
		return id;
	}
	
	public void setId(Long id) {
		this.id = id;
	}
	
	@OneToOne(fetch=FetchType.LAZY)
	@JoinColumn(name="user_account_id",nullable=false)
	@VascModelReference
	public UserAccount getUserAccount() {
		return userAccount;
	}
	
	public void setUserAccount(UserAccount userAccount) {
		this.userAccount = userAccount;
	}
	
	@Column(name="order_date",nullable=false)
	public Date getOrderDate() {
		return orderDate;
	}
	
	public void setOrderDate(Date orderDate) {
		this.orderDate = orderDate;
	}
	
	@Column(name="ship_date",nullable=false)
	@VascField(list=false)
	public Date getShipDate() {
		return shipDate;
	}
	
	public void setShipDate(Date shipDate) {
		this.shipDate = shipDate;
	}
	
	@Column(name="ship_addr1",nullable=false)
	@VascField(list=false)
	public String getShipAddr1() {
		return shipAddr1;
	}
	
	public void setShipAddr1(String shipAddr1) {
		this.shipAddr1 = shipAddr1;
	}
	
	@Column(name="ship_addr2",nullable=false)
	@VascField(list=false)
	public String getShipAddr2() {
		return shipAddr2;
	}
	
	public void setShipAddr2(String shipAddr2) {
		this.shipAddr2 = shipAddr2;
	}
	
	@Column(name="ship_city",nullable=false)
	@VascField(list=false)
	public String getShipCity() {
		return shipCity;
	}
	
	public void setShipCity(String shipCity) {
		this.shipCity = shipCity;
	}
	
	@Column(name="ship_zipcode",nullable=false)
	@VascField(list=false)
	public String getShipZipCode() {
		return shipZipCode;
	}
	
	public void setShipZipCode(String shipZipCode) {
		this.shipZipCode = shipZipCode;
	}
	
	@Column(name="ship_country",nullable=false)
	@VascField(list=false)
	public String getShipCountry() {
		return shipCountry;
	}
	
	public void setShipCountry(String shipCountry) {
		this.shipCountry = shipCountry;
	}
	
	@Column(name="bill_addr1",nullable=false)
	@VascField(list=false)
	public String getBillAddr1() {
		return billAddr1;
	}
	
	public void setBillAddr1(String billAddr1) {
		this.billAddr1 = billAddr1;
	}
	
	@Column(name="bill_addr2",nullable=false)
	@VascField(list=false)
	public String getBillAddr2() {
		return billAddr2;
	}
	
	public void setBillAddr2(String billAddr2) {
		this.billAddr2 = billAddr2;
	}
	
	@Column(name="bill_city",nullable=false)
	@VascField(list=false)
	public String getBillCity() {
		return billCity;
	}
	
	public void setBillCity(String billCity) {
		this.billCity = billCity;
	}
	
	@Column(name="bill_zipcode",nullable=false)
	@VascField(list=false)
	public String getBillZipCode() {
		return billZipCode;
	}
	
	public void setBillZipCode(String billZipCode) {
		this.billZipCode = billZipCode;
	}
	
	@Column(name="bill_country",nullable=false)
	@VascField(list=false)
	public String getBillCountry() {
		return billCountry;
	}
	
	public void setBillCountry(String billCountry) {
		this.billCountry = billCountry;
	}
}
