package net.forwardfire.vasc.demo.tech.domain.petstore.model;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;
import javax.persistence.Table;

import net.forwardfire.vasc.annotations.VascField;
import net.forwardfire.vasc.annotations.VascFieldTemplate;
import net.forwardfire.vasc.annotations.VascModelReference;

@Entity
@Table(name=AbstractPetStoreDBTable.ORDER_LINE,schema=AbstractPetStoreDBCatalog.SCHEMA)
@SuppressWarnings("serial")
public class OrderLine implements Serializable {
	
	private Long id;
	private Order order = null;
	private Integer lineNumber = null;
	private Item item = null;
	private Integer quantity = null;
	private Float itemPrice = null;
	
	@Id
	@Column(name=AbstractPetStoreDBColumn.ID,nullable=false)
	@VascFieldTemplate(templateClass=AbstractPetStoreVascFieldTemplate.class)
	public Long getId() {
		return id;
	}
	
	public void setId(Long id) {
		this.id = id;
	}
	
	@OneToOne(fetch=FetchType.LAZY)
	@JoinColumn(name="order_id",nullable=false)
	@VascModelReference
	public Order getOrder() {
		return order;
	}
	
	public void setOrder(Order order) {
		this.order = order;
	}
	
	@Column(name="line_number",nullable=false)
	@VascField(list=false)
	public Integer getLineNumber() {
		return lineNumber;
	}
	
	public void setLineNumber(Integer lineNumber) {
		this.lineNumber = lineNumber;
	}
	
	@OneToOne(fetch=FetchType.LAZY)
	@JoinColumn(name="item_id",nullable=false)
	@VascModelReference
	public Item getItem() {
		return item;
	}
	
	public void setItem(Item item) {
		this.item = item;
	}
	
	@Column(name="quantity",nullable=false)
	public Integer getQuantity() {
		return quantity;
	}
	
	public void setQuantity(Integer quantity) {
		this.quantity = quantity;
	}
	
	@Column(name="item_price",nullable=false)
	public Float getItemPrice() {
		return itemPrice;
	}
	
	public void setItemPrice(Float itemPrice) {
		this.itemPrice = itemPrice;
	}
}
