package net.forwardfire.vasc.demo.tech.domain.petstore.model;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;

import net.forwardfire.vasc.annotations.VascField;
import net.forwardfire.vasc.annotations.VascFieldTemplate;

@Entity
@Table(name=AbstractPetStoreDBTable.USER_ACCOUNT,schema=AbstractPetStoreDBCatalog.SCHEMA)
@SuppressWarnings("serial")
public class UserAccount implements Serializable {
	
	private Long id;
	private String email = null;
	private String firstName = null;
	private String lastName = null;
	private String streetName = null;
	private String streetNumber = null;
	private String zipCode = null;
	private String country = null;
	private String countryState = null;
	
	@Id
	@Column(name=AbstractPetStoreDBColumn.ID,nullable=false)
	@VascFieldTemplate(templateClass=AbstractPetStoreVascFieldTemplate.class)
	public Long getId() {
		return id;
	}
	
	public void setId(Long id) {
		this.id = id;
	}
	
	@Column(name="email",nullable=false)
	public String getEmail() {
		return email;
	}
	
	public void setEmail(String email) {
		this.email = email;
	}
	
	@Column(name="first_name",nullable=false)
	@VascField(list=false)
	public String getFirstName() {
		return firstName;
	}
	
	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}
	
	@Column(name="last_name",nullable=false)
	@VascField(list=false)
	public String getLastName() {
		return lastName;
	}
	
	public void setLastName(String lastName) {
		this.lastName = lastName;
	}
	
	@Column(name="street_name",nullable=false)
	@VascField(list=false)
	public String getStreetName() {
		return streetName;
	}
	
	public void setStreetName(String streetName) {
		this.streetName = streetName;
	}
	
	@Column(name="street_number",nullable=false)
	@VascField(list=false)
	public String getStreetNumber() {
		return streetNumber;
	}
	
	public void setStreetNumber(String streetNumber) {
		this.streetNumber = streetNumber;
	}
	
	@Column(name="zip_code",nullable=false)
	@VascField(list=false)
	public String getZipCode() {
		return zipCode;
	}
	
	public void setZipCode(String zipCode) {
		this.zipCode = zipCode;
	}
	
	@Column(name="country",nullable=false)
	public String getCountry() {
		return country;
	}
	
	public void setCountry(String country) {
		this.country = country;
	}
	
	@Column(name="country_state",nullable=false)
	@VascField(list=false)
	public String getCountryState() {
		return countryState;
	}
	
	public void setCountryState(String countryState) {
		this.countryState = countryState;
	}
}
