package net.forwardfire.vasc.demo.tech.domain.petstore.model;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;
import javax.persistence.Table;

import net.forwardfire.vasc.annotations.VascField;
import net.forwardfire.vasc.annotations.VascFieldTemplate;
import net.forwardfire.vasc.annotations.VascModelReference;

@Entity
@Table(name=AbstractPetStoreDBTable.USER_CREDENTIAL,schema=AbstractPetStoreDBCatalog.SCHEMA)
@SuppressWarnings("serial")
public class UserCredential implements Serializable {

	private Long id;
	private UserAccount userAccount = null;
	private String password = null;
	private String secretQuestion0 = null;
	private String secretAnswer0 = null;
	private String secretQuestion1 = null;
	private String secretAnswer1 = null;
	
	@Id
	@Column(name=AbstractPetStoreDBColumn.ID,nullable=false)
	@VascFieldTemplate(templateClass=AbstractPetStoreVascFieldTemplate.class)
	public Long getId() {
		return id;
	}
	
	public void setId(Long id) {
		this.id = id;
	}
	
	@OneToOne(fetch=FetchType.LAZY)
	@JoinColumn(name="user_account_id",nullable=false)
	@VascModelReference
	public UserAccount getUserAccount() {
		return userAccount;
	}
	public void setUserAccount(UserAccount userAccount) {
		this.userAccount = userAccount;
	}
	
	@Column(name="password",nullable=false)
	@VascField(list=false)
	public String getPassword() {
		return password;
	}
	public void setPassword(String password) {
		this.password = password;
	}
	
	@Column(name="secret_question0",nullable=false)
	@VascField(list=false)
	public String getSecretQuestion0() {
		return secretQuestion0;
	}
	public void setSecretQuestion0(String secretQuestion0) {
		this.secretQuestion0 = secretQuestion0;
	}
	
	@Column(name="secret_answer0",nullable=false)
	@VascField(list=false)
	public String getSecretAnswer0() {
		return secretAnswer0;
	}
	public void setSecretAnswer0(String secretAnswer0) {
		this.secretAnswer0 = secretAnswer0;
	}
	
	@Column(name="secret_question1",nullable=false)
	@VascField(list=false)
	public String getSecretQuestion1() {
		return secretQuestion1;
	}
	public void setSecretQuestion1(String secretQuestion1) {
		this.secretQuestion1 = secretQuestion1;
	}
	
	@Column(name="secret_answer1",nullable=false)
	@VascField(list=false)
	public String getSecretAnswer1() {
		return secretAnswer1;
	}
	public void setSecretAnswer1(String secretAnswer1) {
		this.secretAnswer1 = secretAnswer1;
	}
}
