package net.forwardfire.vasc.demo.tech.domain.petstore.model;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;
import javax.persistence.Table;

import net.forwardfire.vasc.annotations.VascDefaultValue;
import net.forwardfire.vasc.annotations.VascField;
import net.forwardfire.vasc.annotations.VascFieldTemplate;
import net.forwardfire.vasc.annotations.VascModelReference;

@Entity
@Table(name=AbstractPetStoreDBTable.USER_PROFILE,schema=AbstractPetStoreDBCatalog.SCHEMA)
@SuppressWarnings("serial")
public class UserProfile implements Serializable {
	
	private Long id;
	private String signUpIp = null;
	private String signUpAgent = null;
	private String locale = null;
	private UserAccount userAccount = null;
	private Category userCategory = null;
	
	@Id
	@Column(name=AbstractPetStoreDBColumn.ID,nullable=false)
	@VascFieldTemplate(templateClass=AbstractPetStoreVascFieldTemplate.class)
	public Long getId() {
		return id;
	}
	
	public void setId(Long id) {
		this.id = id;
	}
	
	@Column(name=AbstractPetStoreDBColumn.SIGNUP_IP,nullable=false)
	@VascField(list=false)
	@VascDefaultValue(value="0.0.0.0")
	public String getSignUpIp() {
		return signUpIp;
	}
	
	public void setSignUpIp(String signUpIp) {
		this.signUpIp = signUpIp;
	}
	
	@Column(name=AbstractPetStoreDBColumn.SIGNUP_AGENT,nullable=false)
	@VascField(list=false)
	@VascDefaultValue(value="No-Agent")
	public String getSignUpAgent() {
		return signUpAgent;
	}
	
	public void setSignUpAgent(String signUpAgent) {
		this.signUpAgent = signUpAgent;
	}
	
	@Column(name=AbstractPetStoreDBColumn.LOCALE,nullable=false)
	@VascField(list=false)
	@VascDefaultValue(value="nl_NL")
	public String getLocale() {
		return locale;
	}
	
	public void setLocale(String locale) {
		this.locale = locale;
	}
	
	@OneToOne(fetch=FetchType.LAZY)
	@JoinColumn(name=AbstractPetStoreDBColumn.USER_ACCOUNT_ID,nullable=false)
	@VascModelReference
	public UserAccount getUserAccount() {
		return userAccount;
	}
	
	public void setUserAccount(UserAccount userAccount) {
		this.userAccount = userAccount;
	}
	
	@OneToOne(fetch=FetchType.LAZY)
	@JoinColumn(name=AbstractPetStoreDBColumn.USER_CATEGORY_ID,nullable=false)
	@VascModelReference
	public Category getUserCategory() {
		return userCategory;
	}
	
	public void setUserCategory(Category userCategory) {
		this.userCategory = userCategory;
	}
}
