package net.forwardfire.vasc.demo.tech.ejb3;

import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.ResourceBundle;

import javax.annotation.Resource;
import javax.annotation.security.RolesAllowed;
import javax.ejb.SessionContext;
import javax.ejb.Stateless;

import net.forwardfire.vasc.demo.tech.domain.user.ClientUserControllerLocal;
import net.forwardfire.vasc.demo.tech.domain.user.ClientUserControllerRemote;
import net.forwardfire.vasc.lib.i18n.bundle.RootApplicationBundle;

@Stateless(name="clientUserController")
public class ClientUserControllerImpl implements ClientUserControllerLocal,ClientUserControllerRemote {

    @Resource
    private SessionContext session;
    
    /**
     * Tests for the login role
     */
    @RolesAllowed("login")
    public String doClientLogin() {
    	
    	String name = session.getCallerPrincipal().getName();
    	return name;
    			
    	/*
    	User u = null;
    	try {
    		u = getUser();
    	} catch (Exception e) {
    		throw new IllegalStateException("Could not lookup showplanner user from username: "+session.getCallerPrincipal().getName());
    	}
    	UserSession us = new UserSession();
    	us.setLoginDate(new Date());
    	us.setLogoutDate(null); // set when doing doClientLogout();
    	
    	try {
    		Query q2 = xtesManager.getQuery("users.xml", "getUserSessionStatusByStatusKey");
    		q2.setQueryParameter("status_key", "success");
    		q2.setProperty("limit", 1);
    		UserSessionStatus userSessionStatus =  (UserSessionStatus)xtesManager.executeObject(q2);
    		us.setUserSessionStatus(userSessionStatus);
    	} catch (Exception e) {
    		throw new IllegalStateException("Could not lookup session status of success.");
    	}
    	
    	// current_time_in_secs + str_to_int(username)*10E20
    	long timeSS = us.getLoginDate().getTime();
    	int userSS = hashUserName(u.getUsername());
    	int modSS = 10230;
    	long sessionId = timeSS+userSS*modSS;
    	us.setSessionId(sessionId);
    	//System.out.println("Created sessionId: timeSS: "+timeSS+" userSS: "+userSS+" modSS: "+modSS);
    	
    	us.setUser(u);
    	entityManager.persist(us);
    	return u.getUsername();
    	*/
    }

    public Map<String,String> getResourceBundle(Locale locale) {
    	ResourceBundle bundle = ResourceBundle.getBundle(RootApplicationBundle.class.getName(), locale);
    	if (bundle instanceof RootApplicationBundle) {
    		RootApplicationBundle appBundle = (RootApplicationBundle)bundle;
    		return appBundle.getBundleData();
    	}
    	throw new IllegalStateException("Loaded bundle: "+bundle+" is not RootApplicationBundle.");
    }
    
    public List<Locale> getResourceBundleLocales() {
    	ResourceBundle bundle = ResourceBundle.getBundle(RootApplicationBundle.class.getName());
    	if (bundle instanceof RootApplicationBundle) {
    		RootApplicationBundle appBundle = (RootApplicationBundle)bundle;
    		return appBundle.getApplicationSupportedLocales();
    	}
    	throw new IllegalStateException("Loaded bundle: "+bundle+" is not RootApplicationBundle.");
    }
}
