package net.forwardfire.vasc.demo.tech.web.beans;

import java.util.ArrayList;
import java.util.List;

import javax.faces.model.SelectItem;

import net.forwardfire.vasc.core.VascController;
import net.forwardfire.vasc.impl.jndi.JndiVascControllerProvider;

public class ExportController {

	private String entryId = "VascEntry";
	private String exportType = "xml";
	private boolean exportTree = true; 
	private VascController vascController = null;
	
	public ExportController() {
		try {
			JndiVascControllerProvider p = new JndiVascControllerProvider();
			p.setJndiName("java:comp/env/vasc/server-tech");
			vascController = p.getVascController();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public List<SelectItem> getEntryIdSelectItems() {
		List<SelectItem> result = new ArrayList<SelectItem>();
		for (String entryId:vascController.getVascEntryController().getVascEntryIds()) {
			SelectItem i = new SelectItem();
			String label = entryId;
			while (label.length()>40) {
				label = label.substring(10);
			}
			i.setLabel("..."+label);
			i.setDescription(entryId);
			i.setValue(entryId);
			result.add(i);
		}
		return result;
	}
	
	public List<SelectItem> getExportTypeSelectItems() {
		List<SelectItem> result = new ArrayList<SelectItem>();
		for (String exportId:vascController.getVascEntryConfigController().getVascEntryExporterIds()) {
			SelectItem i = new SelectItem();
			i.setLabel(exportId);
			i.setValue(exportId);
			result.add(i);
		}
		return result;
	}
	
	public String getBuildExportUrl() {
		StringBuilder buff = new StringBuilder();
		if (exportTree) {
			buff.append("export/");
			buff.append(getEntryId());
			buff.append('/');
			buff.append(getExportType());
		} else {
			buff.append("export");
			buff.append("?ve=");
			buff.append(getEntryId());
			buff.append("&amp;et=");
			buff.append(getExportType());
		}
		return buff.toString();
	}
	
	/**
	 * @return the entryId
	 */
	public String getEntryId() {
		return entryId;
	}
	
	/**
	 * @param entryId the entryId to set
	 */
	public void setEntryId(String entryId) {
		this.entryId = entryId;
	}
	
	/**
	 * @return the exportType
	 */
	public String getExportType() {
		return exportType;
	}
	
	/**
	 * @param exportType the exportType to set
	 */
	public void setExportType(String exportType) {
		this.exportType = exportType;
	}

	/**
	 * @return the exportTree
	 */
	public boolean isExportTree() {
		return exportTree;
	}

	/**
	 * @param exportTree the exportTree to set
	 */
	public void setExportTree(boolean exportTree) {
		this.exportTree = exportTree;
	}
}
