package net.forwardfire.vasc.demo.tech.web.faces;

import javax.servlet.ServletContext;

import org.ocpsoft.rewrite.config.And;
import org.ocpsoft.rewrite.config.Condition;
import org.ocpsoft.rewrite.config.Configuration;
import org.ocpsoft.rewrite.config.ConfigurationBuilder;
import org.ocpsoft.rewrite.config.Direction;
import org.ocpsoft.rewrite.config.Operation;
import org.ocpsoft.rewrite.context.EvaluationContext;
import org.ocpsoft.rewrite.event.Rewrite;
import org.ocpsoft.rewrite.servlet.config.Forward;
import org.ocpsoft.rewrite.servlet.config.HttpCondition;
import org.ocpsoft.rewrite.servlet.config.HttpConfigurationProvider;
import org.ocpsoft.rewrite.servlet.config.Path;
import org.ocpsoft.rewrite.servlet.config.Redirect;
import org.ocpsoft.rewrite.servlet.config.rule.Join;
import org.ocpsoft.rewrite.servlet.http.event.HttpServletRewrite;

public class UrlRewriteConfigurationProvider extends HttpConfigurationProvider {

	public Configuration getConfiguration(ServletContext context) {
		HttpCondition authUser = new HttpCondition() {
			@Override
			public boolean evaluateHttp(HttpServletRewrite httpRewrite,EvaluationContext context) {
				return httpRewrite.getRequest().getUserPrincipal()!=null;
			}
		};
		HttpCondition authUserAdmin = new HttpCondition() {
			@Override
			public boolean evaluateHttp(HttpServletRewrite httpRewrite,EvaluationContext context) {
				return httpRewrite.getRequest().isUserInRole("admin");
			}
		};

		return ConfigurationBuilder.begin()
			
				//.addRule(Join.path("/yoyo").to("/html/index.jsf"))
				
				.defineRule()
					.when(Direction.isInbound().
						and(Path.matches("/login")).
						andNot(authUser)
					).
					perform(
						Redirect.temporary("/html/user/index.jsf")
					)
				.defineRule()
					.when(Direction.isInbound().
						and(Path.matches("/login")).
						and(authUser)
					).
					perform(
						Forward.to("/html/user/index.jsf")
					)
					
	
				.defineRule()
					.when(Direction.isInbound().
						and(Path.matches("/home")).
						andNot(authUser)
					).
					perform(
						Forward.to("/html/index.jsf")
					)
				.defineRule()
					.when(Direction.isInbound().
						and(Path.matches("/home")).
						and(authUserAdmin)
					).
					perform(
						Forward.to("/html/admin/index.jsf")
					)
				.defineRule()
					.when(Direction.isInbound().
						and(Path.matches("/home")).
						and(authUser)
					).
					perform(
						Forward.to("/html/user/index.jsf")
					)
					
					
				;

				/*
				.addRule(Join.path("/").to("/pages/loggedOffHome.xhtml")
						.when(loggedIn)
					
         .defineRule()
         .when(Direction.isInbound()
                 .and(Path.matches("/(signup|login)")
                 .andNot(loggedIn)))
         .perform(Redirect.temporary(context.getContextPath() + "/"));
         
         */
	}

	public int priority() {
		return 0;
	}
}
