/*
 * Copyright 2007-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package net.forwardfire.vasc;

import net.forwardfire.vasc.core.VascController;
import net.forwardfire.vasc.core.VascEntryControllerLocal;
import net.forwardfire.vasc.core.VascEntryLocal;
import net.forwardfire.vasc.frontend.swing.SwingPanelFrame;
import net.forwardfire.vasc.frontend.swing.SwingPanelIntegration;
import net.forwardfire.vasc.test.frontend.data.TestModelData;

import junit.framework.TestCase;

/**
 * SwingTestTabbed shows interfaces in frames.
 * 
 * @author Willem Cazander
 * @version 1.0 Jul 24, 2006
 */
public class SwingTest extends TestCase {
    
    public void testNull() throws Exception {
    	assertEquals(true, true);
    	//main(new String[] {});
    }

    public static void main(String[] argu){    	
    	SwingTest s = new SwingTest();
    	try {
			s.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
    }
    
    public void open() throws Exception {
    	SwingPanelIntegration spi = new SwingPanelFrame();
    	TestModelData testData = new TestModelData();
    	VascController vc = testData.getTestVascController();
    	testData.createVascEntries(vc,(VascEntryControllerLocal)vc.getVascEntryController());
    	
    	VascEntryLocal ve = testData.getTestEntry(vc);
    	vc.getVascEntryConfigController().configVascFrontendController(vc, ve);
    	spi.createNewVascView(ve);
    }
}