/*
 * Copyright 2007-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package net.forwardfire.vasc.frontend.swt;

import java.io.Serializable;
import java.util.List;

import net.forwardfire.vasc.core.VascEntry;
import net.forwardfire.vasc.core.actions.GlobalVascAction;
import net.forwardfire.vasc.core.entry.VascEntryFrontendEventListener;
import net.forwardfire.vasc.core.entry.VascEntryFrontendEventListener.VascFrontendEventType;
import net.forwardfire.vasc.frontend.VascFrontendPageInfoNumber;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Layout;
import org.eclipse.swt.widgets.Text;

/**
 * SwtPagerPanel renders pager bar
 * 
 * @author Willem Cazander
 * @version 1.0 May 13, 2009
 */
public class SwtPagerPanel implements VascEntryFrontendEventListener {

	private static final long serialVersionUID = 3747573488962487970L;
	private VascEntry entry = null;
	
	public SwtPagerPanel(VascEntry entry) {
		this.entry=entry;
		entry.getVascFrontendController().addVascEntryFrontendEventListener(this);
	}
	
	public void createComposite(Composite parent) {
        Composite actionRow = new Composite(parent, SWT.NONE);
        GridLayout bodyLayout = new GridLayout();
		bodyLayout.numColumns = 1;
		actionRow.setLayout(bodyLayout);
		actionRow.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		//actionRow.setBackground(c);
        
		Label l = new Label(actionRow, SWT.CENTER);
        l.setText("Pagers");
  	}
	
	
	/**
	 * @see net.forwardfire.vasc.core.entry.VascEntryFrontendEventListener#getEventTypes()
	 */
	@Override
	public VascFrontendEventType[] getEventTypes() {
		VascFrontendEventType[] result = {VascEntryFrontendEventListener.VascFrontendEventType.POST_READ};
		return result;
	}
	
	@Override
	public void vascEvent(VascEntry entry,Serializable dataNotUsed) {

	}
}
