/*
 * Copyright 2007-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package net.forwardfire.vasc;


import net.forwardfire.vasc.core.VascController;
import net.forwardfire.vasc.core.VascEntry;
import net.forwardfire.vasc.core.VascEntryControllerLocal;
import net.forwardfire.vasc.core.VascEntryLocal;
import net.forwardfire.vasc.frontend.swt.SwtVascFrontend;
import net.forwardfire.vasc.impl.DefaultVascFactory;
import net.forwardfire.vasc.test.frontend.data.TestModelData;

import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;





import junit.framework.TestCase;

/**
 * Tests a simple x4o xml language.
 * 
 * @author Willem Cazander
 * @version 1.0 Jul 24, 2006
 */
public class SWTTest extends TestCase {
    
	private TestModelData testData = null;
	
	@Override
    public void setUp() throws Exception {
    }
    
	@Override
    public void tearDown() throws Exception {
    }
    public void testNull() throws Exception {
    	assertEquals(true, true);
    }
    
    public static void main(String[] args) throws Exception {
    	new SWTTest().doSWT();
    }
    
    public void doSWT() throws Exception {
    	
    	// get GUI
    	Display display = new Display();
    	Shell shell = new Shell(display);
    	shell.setText("Vasc Test - Swt");    	
    	  	
    	// define redering and render
    	SwtVascFrontend render = new SwtVascFrontend(shell);
    	
    	testData = new TestModelData();
    	VascController vc = testData.getTestVascController();
    	testData.createVascEntries(vc,(VascEntryControllerLocal)vc.getVascEntryController());

    	VascEntryLocal ve = testData.getTestEntry(vc);
    	vc.getVascEntryConfigController().configVascFrontendController(vc, ve);
    	
    	ve.getVascFrontendController().getVascFrontendActions().refreshData();
    	render.initEntry(ve);
    	render.renderView();
  
    	// view
    	shell.open();
	    // Set up the event loop.
	    while (!shell.isDisposed()) {
	      if (!display.readAndDispatch()) {
	        // If no more entries in event queue
	        display.sleep();
	      }
	    }
	    display.dispose();
    }
}