/*
 * Copyright 2007-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package net.forwardfire.vasc.lib.jr4o.x4o;

import org.x4o.xml.element.AbstractElement;
import org.x4o.xml.element.ElementException;

import net.sf.jasperreports.engine.design.JRDesignBand;
import net.sf.jasperreports.engine.design.JRDesignSection;
import net.sf.jasperreports.engine.design.JasperDesign;

/**
 * 
 *
 * @author Willem Cazander
 * @version 1.0 Aug 31, 2007
 */
public class JasperDesignPageBinderElement extends AbstractElement {
	
	@Override
	public void doElementEnd() throws ElementException {
		
		String tagType = (String)getAttributes().get("tagType");
		
		if (getParent()==null) {
			throw new ElementException("No parent element");
		}
		if ((getParent().getElementObject() instanceof JasperDesign)==false) {
			throw new ElementException("No query parent JRDesignExpression object");
		}
		
		if ("title".equals(tagType)) {
			((JasperDesign)getParent().getElementObject()).setTitle((JRDesignBand)getElementObject());
			return;
		}
		if ("pageHeader".equals(tagType)) {
			((JasperDesign)getParent().getElementObject()).setPageHeader((JRDesignBand)getElementObject());
			return;
		}
		if ("columnHeader".equals(tagType)) {
			((JasperDesign)getParent().getElementObject()).setColumnHeader((JRDesignBand)getElementObject());
			return;
		}
		if ("detail".equals(tagType)) {
			((JRDesignSection)((JasperDesign)getParent().getElementObject()).getDetailSection()).addBand((JRDesignBand)getElementObject());
			return;
		}
		if ("pageFooter".equals(tagType)) {
			((JasperDesign)getParent().getElementObject()).setPageFooter((JRDesignBand)getElementObject());
			return;
		}
		if ("summary".equals(tagType)) {
			((JasperDesign)getParent().getElementObject()).setSummary((JRDesignBand)getElementObject());
			return;
		}
		throw new ElementException("No tagType mathched: "+tagType);
	}
}