package net.forwardfire.vasc.lib.jr4o;

import java.io.File;
import java.util.HashMap;
import java.util.Map;

import javax.swing.table.AbstractTableModel;

import net.forwardfire.vasc.lib.jr4o.JR4ODesignManager.JRExportType;
import net.forwardfire.vasc.lib.jr4o.data.JRDynamicDataSourceTableModel;

import junit.framework.TestCase;

public class JR4ODesignManagerTest extends TestCase {

	public void testExport() throws Exception {
		String testResourceBundle = TestResourceBundle.class.getName();
		TestTableModel testData = new TestTableModel();
		JRDynamicDataSourceTableModel dataModel = new JRDynamicDataSourceTableModel(testData,new int[]{50,100,150});
		Map<String,Object> parameters = new HashMap<String,Object>(5);
		parameters.put("title", "TEST-TITLE");
		parameters.put("description", "TEST-DESCRITION");
		parameters.put("titleSubject", "TEST-SUBJECT");
	
		JR4ODesignManager manager = new JR4ODesignManager(dataModel,testResourceBundle,parameters);
		manager.parseResource("net/forwardfire/vasc/lib/jr4o/reports/dynamic-reports.xml");
		manager.saveReportFile("generic-landscape", JRExportType.PDF, "target/junit-test.pdf");
		
		File output = new File("target/junit-test.pdf");
		assertTrue(output.exists());
		output.delete();
	}
	
	class TestTableModel extends AbstractTableModel {
		private static final long serialVersionUID = 1L;
		String[][] data = new String[][] {
			{"1","test","data"},
			{"2","foo","bar"},
			{"3","bar","foo"},
			{"4","data","test"},
		};
		
		@Override
		public int getColumnCount() {
			return 3;
		}

		@Override
		public int getRowCount() {
			return data.length;
		}

		@Override
		public Object getValueAt(int row, int col) {
			return data[row][col];
		}
	}
}
