/*
 * Copyright 2007-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package net.forwardfire.vasc.xpql.execute.jpa;

import java.util.List;
import java.util.Map;

import javax.ejb.Local;
import javax.ejb.Remote;
import javax.persistence.EntityManager;

import net.forwardfire.vasc.xpql.query.Query;

/**
 * 
 * @author Willem Cazander
 * @version 1.0 17 Sep 2010
 */
public interface XpqlQueryManager {

	Query getQuery(String name);
	
	List<Object> execute(EntityManager entityManager,Query query);
	
	Object executeObject(EntityManager entityManager,Query query);
	
	Integer executeUpdate(EntityManager entityManager,Query query);
	
	List<Object> execute(EntityManager entityManager,String query,Map<String,Object> parameters);
	
	Object executeObject(EntityManager entityManager,String query,Map<String,Object> parameters);
	
	Integer executeUpdate(EntityManager entityManager,String query,Map<String,Object> parameters);
	
	@Local
	public interface ILocal extends XpqlQueryManager {
	}
	
	@Remote
	public interface IRemote extends XpqlQueryManager {
	}
}
