package net.forwardfire.vasc.xpql.execute.jpa;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import javax.naming.Context;
import javax.naming.InitialContext;

import net.forwardfire.vasc.xpql.query.Query;

import org.x4o.xml.element.AbstractElement;
import org.x4o.xml.element.ElementException;

public class XpqlVascJndiQueriesElement extends AbstractElement {

	
	@Override
	public void doElementEnd() throws ElementException {
		
		// set queries map to element object
		Map<String,Query> queries = new HashMap<String,Query>(100);
		setElementObject(queries);
		
		String jndiName = getAttributes().get("jndi");
		if (jndiName==null) {
			throw new ElementException("No 'jndi' attributes defined.");
		}
		if (jndiName.isEmpty()) {
			throw new ElementException("Empty 'jndi' attributes can't load.");
		}
		
		// load queries from ejb3 bean reference
		XpqlQueryManager xpqlManager = null;
		try {
			Context context = new InitialContext();
			xpqlManager = (XpqlQueryManager)context.lookup( jndiName );
		} catch (Exception e) {
			throw new ElementException("Could not get the ejb resource bundle: "+e.getMessage(),e);
		}
		if (xpqlManager==null) {
			throw new ElementException("XpqlQueryManager ejb resource is null.");
		}
		XpqlController refBean = new XpqlController(xpqlManager);
		setElementObject(refBean);
	}
	
	class XpqlController implements Map<String,Query> {
		private XpqlQueryManager xpqlManager = null;
		
		public XpqlController(XpqlQueryManager xpqlManager) {
			this.xpqlManager=xpqlManager;
		}
		
		@Override
		public void clear() {
		}
		
		@Override
		public boolean containsKey(Object key) {
			return true;
		}
		
		@Override
		public boolean containsValue(Object value) {
			return true;
		}
		
		@Override
		public Set<Map.Entry<String, Query>> entrySet() {
			return null;
		}
		
		@Override
		public Query get(Object key) {
			return xpqlManager.getQuery((String)key);
		}
		
		@Override
		public boolean isEmpty() {
			return false;
		}
		
		@Override
		public Set<String> keySet() {
			return null;
		}
		
		@Override
		public Query put(String key, Query value) {
			return null;
		}
		
		@SuppressWarnings("unchecked")
		@Override
		public void putAll(Map m) {
		}
		
		@Override
		public Query remove(Object key) {
			return null;
		}
		
		@Override
		public int size() {
			return 0;
		}
		
		@Override
		public Collection<Query> values() {
			return null;
		}
	}
}
