/*
 * Copyright 2007-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package net.forwardfire.vasc.xpql.impl.x4o;

import java.util.Locale;

import net.forwardfire.vasc.xpql.query.Query.QueryType;

import org.x4o.xml.conv.AbstractStringObjectConverter;
import org.x4o.xml.conv.ObjectConverter;
import org.x4o.xml.conv.ObjectConverterException;

/**
 * QueryTypeObjectConverter converts query type enum.
 * 
 * todo: rm this for the enum conv.
 * 
 * @author Willem Cazander
 * @version 1.0 Jan 21, 2007
 */
public class QueryTypeObjectConverter extends AbstractStringObjectConverter {

	private static final long serialVersionUID = 2383122486722789617L;

	@Override
	public Class<?> getObjectClassTo() {
		return QueryType.class;
	}
	
	@Override
	public String convertStringBack(Object obj,Locale locale) throws ObjectConverterException {
		return ((QueryType)obj).name();
	}

	@Override
	public Object convertStringTo(String str, Locale locale) throws ObjectConverterException {
		try {
			return QueryType.valueOf(""+str);
		} catch (Exception ex) {
			throw new ObjectConverterException(this,"Could not convert to QueryType value="+str,ex);
		}
	}

	@Override
	public ObjectConverter clone() throws CloneNotSupportedException {
		QueryTypeObjectConverter result = new QueryTypeObjectConverter();
		result.converters=cloneConverters();
		return result;
	}
}
