/*
 * Copyright 2007-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package net.forwardfire.vasc.xpql.query;

/**
 * 
 * @author Willem Cazander
 * @version 1.0 Mar 4, 2007
 */
abstract public class AbstractQueryParameterValue implements QueryParameterValue {

	private String name = null;
	private Object value = null;
	private Object defaultValue	= null;
	private QueryParameterType type = null;
	private Class<?> valueType = null;
	
	/**
	 * @see net.forwardfire.vasc.xpql.query.QueryParameterValue#getName()
	 */
	@Override
	public String getName() {
		return name;
	}
	
	/**
	 * @see net.forwardfire.vasc.xpql.query.QueryParameterValue#setName(java.lang.String)
	 */
	@Override
	public void setName(String name) {
		this.name=name;
	}
	
	/**
	 * @see net.forwardfire.vasc.xpql.query.QueryParameterValue#getDefaultValue()
	 */
	@Override
	public Object getDefaultValue() {
		return defaultValue;
	}
	
	/**
	 * @see net.forwardfire.vasc.xpql.query.QueryParameterValue#setDefaultValue(java.lang.Object)
	 */
	@Override
	public void setDefaultValue(Object defaultValue) {
		this.defaultValue=defaultValue;
	}

	/**
	 * @see net.forwardfire.vasc.xpql.query.QueryParameterValue#getValue()
	 */
	@Override
	public Object getValue() {
		return value;
	}
	
	/**
	 * @see net.forwardfire.vasc.xpql.query.QueryParameterValue#setType(net.forwardfire.vasc.xpql.query.QueryParameterValue.QueryParameterType)
	 */
	@Override
	public void setType(QueryParameterType type) {
		this.type=type;
	}
	
	/**
	 * @see net.forwardfire.vasc.xpql.query.QueryParameterValue#getType()
	 */
	@Override
	public QueryParameterType getType() {
		return type;
	}

	/**
	 * @see net.forwardfire.vasc.xpql.query.QueryParameterValue#setValue(java.lang.Object)
	 */
	@Override
	public void setValue(Object value) {
		this.value=value;
	}

	/**
	 * @return the valueType
	 */
	@Override
	public Class<?> getValueType() {
		return valueType;
	}

	/**
	 * @param valueType the valueType to set
	 */
	@Override
	public void setValueType(Class<?> valueType) {
		this.valueType = valueType;
	}
	
	@Override
	abstract public QueryParameterValue clone() throws CloneNotSupportedException;
}
