package net.forwardfire.vasc.xpql.x4o;

import java.util.HashMap;
import java.util.Map;
import java.util.logging.Logger;

import net.forwardfire.vasc.xpql.QueryStore;
import net.forwardfire.vasc.xpql.XPQLDriver;
import net.forwardfire.vasc.xpql.query.Query;

import org.x4o.xml.element.AbstractElement;
import org.x4o.xml.element.ElementException;
import org.x4o.xml.io.X4OReader;

public class XpqlLoadQueriesElement extends AbstractElement {

	private Logger logger = Logger.getLogger(XpqlLoadQueriesElement.class.getName());
	
	@Override
	public void doElementEnd() throws ElementException {
		
		// set queries map to element object
		Map<String,Query> queries = new HashMap<String,Query>(100);
		setElementObject(queries);
		
		String resource = getAttributes().get("resource");
		if (resource==null) {
			throw new ElementException("No 'resource' attributes defined.");
		}
		if (resource.isEmpty()) {
			throw new ElementException("Empty 'resource' attributes can't load.");
		}
		
		// load queries from attributes
		XPQLDriver driver = new XPQLDriver();
		X4OReader<QueryStore> reader = driver.createReader();
		QueryStore store = null;
		try {
			store = reader.readResource(resource);
		} catch (Exception e) {
			throw new ElementException(e);
		}
		for (String key:store.getQueryNames()) {
			Query q = store.getQuery(key);
			queries.put(q.getName(),q);
		}
		logger.info("Loaded xpql queries: "+store.getQueryNames().size());
	}
}
