/*
 * Copyright 2007-2012 forwardfire.net All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided
 * that the following conditions are met:
 * 
 * * Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *   following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package net.forwardfire.vasc.opt.metamodel.x4o;

import net.forwardfire.vasc.core.VascController;
import net.forwardfire.vasc.impl.x4o.VascDriver;
import net.forwardfire.vasc.opt.metamodel.MetaModelSchemaAutoEntry;

import org.x4o.xml.element.AbstractElementConfigurator;
import org.x4o.xml.element.Element;
import org.x4o.xml.element.ElementConfiguratorException;

/**
 * SchemaAutoEntryElementConfigurator runs the autoCreateEntries method the MetaModelSchemaAutoEntry bean.
 * 
 * @author Willem Cazander
 * @version 1.0 May 12, 2012
 */
public class SchemaAutoEntryElementConfigurator extends AbstractElementConfigurator {
	
	/**
	 * @see org.x4o.xml.element.AbstractElementConfigurator#doConfigEndTag(org.x4o.xml.element.Element)
	 */
	@Override
	public void doConfigElement(Element element) throws ElementConfiguratorException {

		if (element.getElementObject()==null) {
			throw new ElementConfiguratorException(this,"ElementObject is null");
		}
		if ((element.getElementObject() instanceof MetaModelSchemaAutoEntry)==false) {
			throw new ElementConfiguratorException(this,"ElementObject is not MetaModelSchemaAutoEntry object.");
		}
		MetaModelSchemaAutoEntry autoEntry = (MetaModelSchemaAutoEntry)element.getElementObject();
		VascController vascController = VascDriver.getVascController(element.getLanguageSession());
		autoEntry.autoFillResult(vascController);
		autoEntry.autoAddResultToController();
	}
}
